/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "conf_parser.y" /* yacc.c:339  */


#define YY_NO_UNPUT
#include <sys/types.h>
#include <string.h>

#include "config.h"
#include "stdinc.h"
#include "ircd.h"
#include "list.h"
#include "conf.h"
#include "conf_class.h"
#include "event.h"
#include "log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "irc_string.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h"
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "motd.h"
#include "hook.h"
#include "ssl.h"

#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/dh.h>

#include "rsa.h"

int yylex(void);

static struct
{
  struct {
    dlink_list list;
  } mask,
    leaf,
    hub;

  struct {
    char buf[IRCD_BUFSIZE];
  } name,
    user,
    host,
    addr,
    bind,
    file,
    cert,
    ca,
    profile,
    rpass,
    spass,
    class,
    reason;

  struct {
    unsigned int value;
  } flags,
    modes,
    snomask_local,
    snomask_remote,
    size,
    type,
    port,
    aftype,
    ping_freq,
    max_perip,
    con_freq,
    min_idle,
    max_idle,
    max_total,
    max_global,
    max_local,
    soft_sendq,
    flood_burst,
    flood_limit,
    max_sendq,
    max_recvq,
    cidr_bitlen_ipv4,
    cidr_bitlen_ipv6,
    number_per_cidr,
    max_channels;

  struct
  {
    struct alias_entry *alias;
    struct sslprofile *ssl;
    struct sslprofile_identity *identity;
    struct dnsbl_entry *dnsbl;
    struct cloak_config *cloak;
  } ptr;
} block_state;

static void
reset_block_state(void)
{
  dlink_node *ptr = NULL, *ptr_next = NULL;

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.mask.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.mask.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.leaf.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.leaf.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.hub.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.hub.list);
    free_dlink_node(ptr);
  }

  memset(&block_state, 0, sizeof(block_state));
}


#line 197 "conf_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CONF_PARSER_H_INCLUDED
# define YY_YY_CONF_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACCEPT_PASSWORD = 258,
    ACCOUNT_WHOIS = 259,
    ADMIN = 260,
    AFTYPE = 261,
    ANTI_NICK_FLOOD = 262,
    ANTI_SPAM_EXIT_MESSAGE_TIME = 263,
    AUTOCONN = 264,
    BYTES = 265,
    KBYTES = 266,
    MBYTES = 267,
    CA_FILE = 268,
    CALLER_ID_WAIT = 269,
    CAN_FLOOD = 270,
    CHANNEL = 271,
    CIDR_BITLEN_IPV4 = 272,
    CIDR_BITLEN_IPV6 = 273,
    CIPHER_LIST = 274,
    CLASS = 275,
    CLOAK = 276,
    CLOAK_KEY = 277,
    CLOAK_KEY1 = 278,
    CLOAK_KEY2 = 279,
    CLOAK_KEY3 = 280,
    CONNECT = 281,
    CONNECTFREQ = 282,
    CYCLE_ON_HOST_CHANGE = 283,
    DEFAULT = 284,
    DEFAULT_FLOODCOUNT = 285,
    DEFAULT_FLOODTIME = 286,
    DEFAULT_SPLIT_SERVER_COUNT = 287,
    DEFAULT_SPLIT_USER_COUNT = 288,
    DEFER = 289,
    DENY = 290,
    DESCRIPTION = 291,
    DIE = 292,
    DISABLE_AUTH = 293,
    DISABLE_CHMODES = 294,
    DISABLE_FAKE_CHANNELS = 295,
    DISABLE_REMOTE_COMMANDS = 296,
    DNSBL = 297,
    DNSBL_EXEMPT = 298,
    DOTS_IN_IDENT = 299,
    DURATION = 300,
    EMAIL = 301,
    ENABLE_EXTBANS = 302,
    ENABLE_FORWARDING = 303,
    ENCRYPTED = 304,
    EXCEED_LIMIT = 305,
    EXEMPT = 306,
    FAILED_OPER_NOTICE = 307,
    FLATTEN_LINKS = 308,
    FLOOD_BURST = 309,
    FLOOD_LIMIT = 310,
    GECOS = 311,
    GENERAL = 312,
    GLINE = 313,
    GLINE_DURATION = 314,
    GLINE_ENABLE = 315,
    GLINE_EXEMPT = 316,
    GLINE_MIN_CIDR = 317,
    GLINE_MIN_CIDR6 = 318,
    GLINE_REQUEST_DURATION = 319,
    HAVENT_READ_CONF = 320,
    HIDDEN = 321,
    HIDDEN_NAME = 322,
    HIDE_IDLE_FROM_OPERS = 323,
    HIDE_SERVER_IPS = 324,
    HIDE_SERVERS = 325,
    HIDE_SERVICES = 326,
    HIDE_SPOOF_IPS = 327,
    HOST = 328,
    HTTP = 329,
    HUB = 330,
    HUB_MASK = 331,
    IDENTITY = 332,
    IGNORE_BOGUS_TS = 333,
    INVISIBLE_ON_CONNECT = 334,
    INVITE_THROTTLE = 335,
    IP = 336,
    IRCD_AUTH = 337,
    IRCD_FLAGS = 338,
    IRCD_SID = 339,
    JOIN_FLOOD_COUNT = 340,
    JOIN_FLOOD_TIME = 341,
    KILL = 342,
    KILL_CHASE_TIME_LIMIT = 343,
    KLINE = 344,
    KLINE_EXEMPT = 345,
    KLINE_REASON = 346,
    KNOCK_DELAY = 347,
    KNOCK_DELAY_CHANNEL = 348,
    LEAF_MASK = 349,
    T_LINK = 350,
    LINKS_DELAY = 351,
    LISTEN = 352,
    MASK = 353,
    MATCH = 354,
    MAX_ACCEPT = 355,
    MAX_BANS = 356,
    MAX_CHANNELS = 357,
    MAX_CHANS_PER_USER = 358,
    MAX_GLOBAL = 359,
    MAX_IDLE = 360,
    MAX_LOCAL = 361,
    MAX_NICK_CHANGES = 362,
    MAX_NICK_LENGTH = 363,
    MAX_NICK_TIME = 364,
    MAX_NUMBER = 365,
    MAX_TARGETS = 366,
    MAX_TOPIC_LENGTH = 367,
    MAX_WATCH = 368,
    MIN_IDLE = 369,
    MIN_NONWILDCARD = 370,
    MIN_NONWILDCARD_SIMPLE = 371,
    MODULE = 372,
    MODULES = 373,
    MOTD = 374,
    NAME = 375,
    NEED_ACCOUNT = 376,
    NEED_IDENT = 377,
    NEED_PASSWORD = 378,
    NETWORK_DESC = 379,
    NETWORK_NAME = 380,
    NICK = 381,
    NICK_COLLIDE_REALHOST = 382,
    NO_CREATE_ON_SPLIT = 383,
    NO_JOIN_ON_SPLIT = 384,
    NO_OPER_FLOOD = 385,
    NO_TILDE = 386,
    NUMBER = 387,
    NUMBER_PER_CIDR = 388,
    NUMBER_PER_IP = 389,
    OPER_ONLY = 390,
    OPER_ONLY_UMODES = 391,
    OPER_PASS_RESV = 392,
    OPER_SNOMASKS = 393,
    OPER_UMODES = 394,
    OPERATOR = 395,
    OPERS_BYPASS_CALLERID = 396,
    PACE_WAIT = 397,
    PACE_WAIT_SIMPLE = 398,
    PASSWORD = 399,
    PATH = 400,
    PING_COOKIE = 401,
    PING_TIME = 402,
    PORT = 403,
    QSTRING = 404,
    QUIET_ON_BAN = 405,
    RANDOM_IDLE = 406,
    REASON = 407,
    REDIRPORT = 408,
    REDIRSERV = 409,
    REHASH = 410,
    REMOTE = 411,
    REMOTEBAN = 412,
    RESV = 413,
    RESV_EXEMPT = 414,
    RSA_PRIVATE_KEY_FILE = 415,
    RSA_PUBLIC_KEY_FILE = 416,
    SECONDS = 417,
    MINUTES = 418,
    HOURS = 419,
    DAYS = 420,
    WEEKS = 421,
    MONTHS = 422,
    YEARS = 423,
    SEND_PASSWORD = 424,
    SENDQ = 425,
    SERVERHIDE = 426,
    SERVERINFO = 427,
    SERVER_NAME = 428,
    SESSION = 429,
    SHORT_MOTD = 430,
    T_SNOMASKS = 431,
    SOFT_SENDQ = 432,
    SPOOF = 433,
    SPOOF_NOTICE = 434,
    SQUIT = 435,
    SSL_CERTIFICATE_FILE = 436,
    SSL_CERTIFICATE_FINGERPRINT = 437,
    SSL_CONNECTION_REQUIRED = 438,
    SSL_DH_ELLIPTIC_CURVE = 439,
    SSL_DH_PARAM_FILE = 440,
    SSL_MESSAGE_DIGEST_ALGORITHM = 441,
    SSLPROFILE = 442,
    SSL_PROFILE = 443,
    STATS_E_DISABLED = 444,
    STATS_I_OPER_ONLY = 445,
    STATS_K_OPER_ONLY = 446,
    STATS_M_OPER_ONLY = 447,
    STATS_O_OPER_ONLY = 448,
    STATS_P_OPER_ONLY = 449,
    STATS_U_OPER_ONLY = 450,
    T_ALIAS = 451,
    T_ALL = 452,
    T_BOTS = 453,
    T_CALLERID = 454,
    T_CCONN = 455,
    T_CLUSTER = 456,
    T_DEAF = 457,
    T_DEBUG = 458,
    T_DLINE = 459,
    T_FARCONNECT = 460,
    T_FILE = 461,
    T_FULL = 462,
    T_HIDECHANNELS = 463,
    T_GLOBOPS = 464,
    T_INVISIBLE = 465,
    T_IPV4 = 466,
    T_IPV6 = 467,
    T_LOCOPS = 468,
    T_LOG = 469,
    T_MAX_CLIENTS = 470,
    T_NCHANGE = 471,
    T_NOCTCP = 472,
    T_NONONREG = 473,
    T_OPERWALL = 474,
    T_RECVQ = 475,
    T_REJ = 476,
    T_RESTART = 477,
    T_SASL_NAME = 478,
    T_SERVER = 479,
    T_SERVICE = 480,
    T_SERVICES_NAME = 481,
    T_SERVNOTICE = 482,
    T_SET = 483,
    T_SHARED = 484,
    T_SIZE = 485,
    T_SKILL = 486,
    T_SOFTCALLERID = 487,
    T_SPY = 488,
    T_SSL = 489,
    T_UMODES = 490,
    T_UNAUTH = 491,
    T_UNDLINE = 492,
    T_UNLIMITED = 493,
    T_UNRESV = 494,
    T_UNXLINE = 495,
    T_WALLOP = 496,
    T_WALLOPS = 497,
    T_WALLUSERS = 498,
    T_WEBIRC = 499,
    TBOOL = 500,
    THROTTLE_NUM = 501,
    THROTTLE_TIME = 502,
    TKLINE_EXPIRE_NOTICES = 503,
    TMASKED = 504,
    MASS_HIGHLIGHT_NICKS = 505,
    TS_MAX_DELTA = 506,
    TS_WARN_DELTA = 507,
    TWODOTS = 508,
    TYPE = 509,
    UNKLINE = 510,
    USE_LOGGING = 511,
    USE_TARGET_CHANGE = 512,
    USER = 513,
    VHOST = 514,
    VHOST6 = 515,
    WARN_NO_NLINE = 516,
    WLINE = 517,
    XLINE = 518
  };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACCOUNT_WHOIS 259
#define ADMIN 260
#define AFTYPE 261
#define ANTI_NICK_FLOOD 262
#define ANTI_SPAM_EXIT_MESSAGE_TIME 263
#define AUTOCONN 264
#define BYTES 265
#define KBYTES 266
#define MBYTES 267
#define CA_FILE 268
#define CALLER_ID_WAIT 269
#define CAN_FLOOD 270
#define CHANNEL 271
#define CIDR_BITLEN_IPV4 272
#define CIDR_BITLEN_IPV6 273
#define CIPHER_LIST 274
#define CLASS 275
#define CLOAK 276
#define CLOAK_KEY 277
#define CLOAK_KEY1 278
#define CLOAK_KEY2 279
#define CLOAK_KEY3 280
#define CONNECT 281
#define CONNECTFREQ 282
#define CYCLE_ON_HOST_CHANGE 283
#define DEFAULT 284
#define DEFAULT_FLOODCOUNT 285
#define DEFAULT_FLOODTIME 286
#define DEFAULT_SPLIT_SERVER_COUNT 287
#define DEFAULT_SPLIT_USER_COUNT 288
#define DEFER 289
#define DENY 290
#define DESCRIPTION 291
#define DIE 292
#define DISABLE_AUTH 293
#define DISABLE_CHMODES 294
#define DISABLE_FAKE_CHANNELS 295
#define DISABLE_REMOTE_COMMANDS 296
#define DNSBL 297
#define DNSBL_EXEMPT 298
#define DOTS_IN_IDENT 299
#define DURATION 300
#define EMAIL 301
#define ENABLE_EXTBANS 302
#define ENABLE_FORWARDING 303
#define ENCRYPTED 304
#define EXCEED_LIMIT 305
#define EXEMPT 306
#define FAILED_OPER_NOTICE 307
#define FLATTEN_LINKS 308
#define FLOOD_BURST 309
#define FLOOD_LIMIT 310
#define GECOS 311
#define GENERAL 312
#define GLINE 313
#define GLINE_DURATION 314
#define GLINE_ENABLE 315
#define GLINE_EXEMPT 316
#define GLINE_MIN_CIDR 317
#define GLINE_MIN_CIDR6 318
#define GLINE_REQUEST_DURATION 319
#define HAVENT_READ_CONF 320
#define HIDDEN 321
#define HIDDEN_NAME 322
#define HIDE_IDLE_FROM_OPERS 323
#define HIDE_SERVER_IPS 324
#define HIDE_SERVERS 325
#define HIDE_SERVICES 326
#define HIDE_SPOOF_IPS 327
#define HOST 328
#define HTTP 329
#define HUB 330
#define HUB_MASK 331
#define IDENTITY 332
#define IGNORE_BOGUS_TS 333
#define INVISIBLE_ON_CONNECT 334
#define INVITE_THROTTLE 335
#define IP 336
#define IRCD_AUTH 337
#define IRCD_FLAGS 338
#define IRCD_SID 339
#define JOIN_FLOOD_COUNT 340
#define JOIN_FLOOD_TIME 341
#define KILL 342
#define KILL_CHASE_TIME_LIMIT 343
#define KLINE 344
#define KLINE_EXEMPT 345
#define KLINE_REASON 346
#define KNOCK_DELAY 347
#define KNOCK_DELAY_CHANNEL 348
#define LEAF_MASK 349
#define T_LINK 350
#define LINKS_DELAY 351
#define LISTEN 352
#define MASK 353
#define MATCH 354
#define MAX_ACCEPT 355
#define MAX_BANS 356
#define MAX_CHANNELS 357
#define MAX_CHANS_PER_USER 358
#define MAX_GLOBAL 359
#define MAX_IDLE 360
#define MAX_LOCAL 361
#define MAX_NICK_CHANGES 362
#define MAX_NICK_LENGTH 363
#define MAX_NICK_TIME 364
#define MAX_NUMBER 365
#define MAX_TARGETS 366
#define MAX_TOPIC_LENGTH 367
#define MAX_WATCH 368
#define MIN_IDLE 369
#define MIN_NONWILDCARD 370
#define MIN_NONWILDCARD_SIMPLE 371
#define MODULE 372
#define MODULES 373
#define MOTD 374
#define NAME 375
#define NEED_ACCOUNT 376
#define NEED_IDENT 377
#define NEED_PASSWORD 378
#define NETWORK_DESC 379
#define NETWORK_NAME 380
#define NICK 381
#define NICK_COLLIDE_REALHOST 382
#define NO_CREATE_ON_SPLIT 383
#define NO_JOIN_ON_SPLIT 384
#define NO_OPER_FLOOD 385
#define NO_TILDE 386
#define NUMBER 387
#define NUMBER_PER_CIDR 388
#define NUMBER_PER_IP 389
#define OPER_ONLY 390
#define OPER_ONLY_UMODES 391
#define OPER_PASS_RESV 392
#define OPER_SNOMASKS 393
#define OPER_UMODES 394
#define OPERATOR 395
#define OPERS_BYPASS_CALLERID 396
#define PACE_WAIT 397
#define PACE_WAIT_SIMPLE 398
#define PASSWORD 399
#define PATH 400
#define PING_COOKIE 401
#define PING_TIME 402
#define PORT 403
#define QSTRING 404
#define QUIET_ON_BAN 405
#define RANDOM_IDLE 406
#define REASON 407
#define REDIRPORT 408
#define REDIRSERV 409
#define REHASH 410
#define REMOTE 411
#define REMOTEBAN 412
#define RESV 413
#define RESV_EXEMPT 414
#define RSA_PRIVATE_KEY_FILE 415
#define RSA_PUBLIC_KEY_FILE 416
#define SECONDS 417
#define MINUTES 418
#define HOURS 419
#define DAYS 420
#define WEEKS 421
#define MONTHS 422
#define YEARS 423
#define SEND_PASSWORD 424
#define SENDQ 425
#define SERVERHIDE 426
#define SERVERINFO 427
#define SERVER_NAME 428
#define SESSION 429
#define SHORT_MOTD 430
#define T_SNOMASKS 431
#define SOFT_SENDQ 432
#define SPOOF 433
#define SPOOF_NOTICE 434
#define SQUIT 435
#define SSL_CERTIFICATE_FILE 436
#define SSL_CERTIFICATE_FINGERPRINT 437
#define SSL_CONNECTION_REQUIRED 438
#define SSL_DH_ELLIPTIC_CURVE 439
#define SSL_DH_PARAM_FILE 440
#define SSL_MESSAGE_DIGEST_ALGORITHM 441
#define SSLPROFILE 442
#define SSL_PROFILE 443
#define STATS_E_DISABLED 444
#define STATS_I_OPER_ONLY 445
#define STATS_K_OPER_ONLY 446
#define STATS_M_OPER_ONLY 447
#define STATS_O_OPER_ONLY 448
#define STATS_P_OPER_ONLY 449
#define STATS_U_OPER_ONLY 450
#define T_ALIAS 451
#define T_ALL 452
#define T_BOTS 453
#define T_CALLERID 454
#define T_CCONN 455
#define T_CLUSTER 456
#define T_DEAF 457
#define T_DEBUG 458
#define T_DLINE 459
#define T_FARCONNECT 460
#define T_FILE 461
#define T_FULL 462
#define T_HIDECHANNELS 463
#define T_GLOBOPS 464
#define T_INVISIBLE 465
#define T_IPV4 466
#define T_IPV6 467
#define T_LOCOPS 468
#define T_LOG 469
#define T_MAX_CLIENTS 470
#define T_NCHANGE 471
#define T_NOCTCP 472
#define T_NONONREG 473
#define T_OPERWALL 474
#define T_RECVQ 475
#define T_REJ 476
#define T_RESTART 477
#define T_SASL_NAME 478
#define T_SERVER 479
#define T_SERVICE 480
#define T_SERVICES_NAME 481
#define T_SERVNOTICE 482
#define T_SET 483
#define T_SHARED 484
#define T_SIZE 485
#define T_SKILL 486
#define T_SOFTCALLERID 487
#define T_SPY 488
#define T_SSL 489
#define T_UMODES 490
#define T_UNAUTH 491
#define T_UNDLINE 492
#define T_UNLIMITED 493
#define T_UNRESV 494
#define T_UNXLINE 495
#define T_WALLOP 496
#define T_WALLOPS 497
#define T_WALLUSERS 498
#define T_WEBIRC 499
#define TBOOL 500
#define THROTTLE_NUM 501
#define THROTTLE_TIME 502
#define TKLINE_EXPIRE_NOTICES 503
#define TMASKED 504
#define MASS_HIGHLIGHT_NICKS 505
#define TS_MAX_DELTA 506
#define TS_WARN_DELTA 507
#define TWODOTS 508
#define TYPE 509
#define UNKLINE 510
#define USE_LOGGING 511
#define USE_TARGET_CHANGE 512
#define USER 513
#define VHOST 514
#define VHOST6 515
#define WARN_NO_NLINE 516
#define WLINE 517
#define XLINE 518

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 159 "conf_parser.y" /* yacc.c:355  */

  int number;
  char *string;

#line 768 "conf_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CONF_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 785 "conf_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1569

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  270
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  351
/* YYNRULES -- Number of rules.  */
#define YYNRULES  769
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1539

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   518

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   268,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   269,   264,
       2,   267,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   266,     2,   265,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   426,   426,   427,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   460,   460,   461,   465,   469,   473,   477,   481,   485,
     489,   495,   495,   496,   497,   498,   499,   506,   505,   520,
     520,   521,   521,   521,   521,   521,   523,   536,   542,   548,
     560,   563,   563,   564,   564,   564,   566,   572,   580,   579,
     628,   628,   629,   629,   629,   630,   630,   631,   632,   634,
     642,   674,   700,   708,   717,   716,   738,   738,   739,   739,
     740,   741,   743,   758,   818,   859,   861,   861,   862,   862,
     863,   863,   864,   864,   865,   865,   866,   867,   868,   869,
     872,   887,   902,   911,   925,   934,   962,   992,  1017,  1039,
    1061,  1070,  1072,  1072,  1073,  1073,  1074,  1074,  1076,  1085,
    1094,  1107,  1106,  1124,  1124,  1125,  1125,  1125,  1127,  1133,
    1144,  1143,  1169,  1169,  1171,  1171,  1171,  1171,  1173,  1179,
    1185,  1186,  1186,  1187,  1214,  1213,  1230,  1230,  1231,  1232,
    1233,  1234,  1235,  1236,  1237,  1239,  1245,  1251,  1262,  1273,
    1284,  1298,  1299,  1299,  1301,  1301,  1302,  1304,  1311,  1311,
    1324,  1325,  1327,  1327,  1328,  1328,  1330,  1338,  1341,  1347,
    1346,  1352,  1352,  1353,  1357,  1361,  1365,  1369,  1373,  1377,
    1381,  1385,  1396,  1395,  1476,  1476,  1477,  1477,  1477,  1478,
    1478,  1478,  1478,  1479,  1479,  1480,  1481,  1481,  1483,  1489,
    1495,  1501,  1512,  1518,  1524,  1535,  1542,  1541,  1547,  1547,
    1548,  1549,  1554,  1559,  1564,  1569,  1574,  1579,  1584,  1589,
    1594,  1599,  1604,  1611,  1610,  1616,  1616,  1618,  1623,  1628,
    1633,  1638,  1643,  1648,  1653,  1658,  1663,  1668,  1673,  1678,
    1685,  1684,  1690,  1690,  1691,  1695,  1699,  1703,  1707,  1711,
    1715,  1719,  1723,  1727,  1731,  1735,  1739,  1743,  1747,  1751,
    1755,  1759,  1763,  1767,  1771,  1775,  1779,  1783,  1787,  1791,
    1795,  1806,  1805,  1864,  1864,  1865,  1866,  1866,  1867,  1868,
    1869,  1870,  1871,  1872,  1873,  1874,  1874,  1874,  1874,  1874,
    1875,  1876,  1877,  1878,  1879,  1881,  1887,  1893,  1899,  1905,
    1911,  1917,  1923,  1929,  1935,  1941,  1947,  1954,  1960,  1966,
    1972,  1981,  1990,  1997,  1996,  2002,  2002,  2003,  2007,  2018,
    2017,  2024,  2023,  2029,  2029,  2030,  2034,  2038,  2042,  2046,
    2052,  2052,  2053,  2053,  2053,  2053,  2053,  2053,  2056,  2055,
    2061,  2061,  2063,  2082,  2105,  2111,  2117,  2127,  2126,  2191,
    2191,  2192,  2192,  2192,  2192,  2193,  2193,  2193,  2194,  2194,
    2195,  2195,  2197,  2203,  2209,  2215,  2227,  2226,  2232,  2232,
    2233,  2237,  2241,  2245,  2249,  2253,  2257,  2261,  2265,  2269,
    2273,  2277,  2283,  2297,  2306,  2315,  2323,  2336,  2335,  2350,
    2350,  2351,  2351,  2351,  2351,  2353,  2359,  2365,  2375,  2377,
    2377,  2378,  2378,  2380,  2396,  2395,  2420,  2420,  2421,  2421,
    2421,  2421,  2423,  2429,  2449,  2448,  2454,  2454,  2455,  2459,
    2463,  2467,  2471,  2475,  2479,  2483,  2487,  2491,  2495,  2499,
    2509,  2508,  2529,  2529,  2530,  2530,  2530,  2532,  2539,  2538,
    2544,  2544,  2545,  2549,  2553,  2557,  2561,  2565,  2569,  2573,
    2577,  2581,  2591,  2590,  2677,  2677,  2678,  2678,  2678,  2679,
    2679,  2680,  2680,  2680,  2681,  2681,  2682,  2682,  2682,  2683,
    2683,  2684,  2686,  2692,  2698,  2704,  2717,  2730,  2736,  2742,
    2748,  2754,  2758,  2767,  2766,  2771,  2771,  2772,  2776,  2782,
    2793,  2799,  2805,  2816,  2815,  2841,  2841,  2842,  2842,  2842,
    2844,  2864,  2874,  2873,  2900,  2900,  2901,  2901,  2901,  2903,
    2909,  2918,  2920,  2920,  2921,  2921,  2923,  2941,  2940,  2963,
    2963,  2964,  2964,  2964,  2966,  2972,  2981,  2984,  2984,  2985,
    2985,  2986,  2986,  2987,  2987,  2988,  2988,  2989,  2989,  2990,
    2991,  2992,  2992,  2993,  2993,  2994,  2994,  2994,  2995,  2995,
    2996,  2997,  2997,  2998,  2999,  2999,  3000,  3000,  3000,  3001,
    3001,  3001,  3002,  3002,  3003,  3003,  3003,  3004,  3004,  3005,
    3006,  3006,  3007,  3007,  3008,  3009,  3010,  3011,  3012,  3012,
    3012,  3013,  3014,  3015,  3015,  3015,  3016,  3016,  3016,  3017,
    3018,  3021,  3026,  3032,  3041,  3047,  3053,  3059,  3065,  3070,
    3075,  3084,  3089,  3094,  3099,  3104,  3109,  3114,  3119,  3124,
    3129,  3134,  3139,  3145,  3156,  3161,  3166,  3171,  3176,  3181,
    3186,  3189,  3194,  3197,  3202,  3207,  3212,  3217,  3222,  3227,
    3232,  3237,  3242,  3247,  3252,  3261,  3270,  3275,  3280,  3285,
    3290,  3296,  3295,  3300,  3305,  3310,  3322,  3327,  3327,  3328,
    3332,  3336,  3340,  3344,  3348,  3352,  3356,  3360,  3364,  3368,
    3372,  3378,  3377,  3382,  3382,  3384,  3388,  3392,  3396,  3400,
    3404,  3408,  3412,  3416,  3420,  3424,  3428,  3432,  3438,  3437,
    3442,  3442,  3443,  3447,  3451,  3455,  3459,  3463,  3467,  3471,
    3475,  3479,  3483,  3487,  3492,  3501,  3506,  3511,  3516,  3521,
    3530,  3533,  3533,  3534,  3535,  3535,  3536,  3537,  3538,  3539,
    3540,  3541,  3541,  3542,  3542,  3543,  3543,  3545,  3550,  3555,
    3560,  3565,  3570,  3575,  3580,  3585,  3590,  3595,  3600,  3605,
    3613,  3616,  3616,  3617,  3617,  3618,  3619,  3620,  3621,  3621,
    3622,  3623,  3625,  3631,  3637,  3643,  3649,  3658,  3672,  3678
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACCOUNT_WHOIS",
  "ADMIN", "AFTYPE", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "BYTES", "KBYTES", "MBYTES", "CA_FILE", "CALLER_ID_WAIT",
  "CAN_FLOOD", "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6",
  "CIPHER_LIST", "CLASS", "CLOAK", "CLOAK_KEY", "CLOAK_KEY1", "CLOAK_KEY2",
  "CLOAK_KEY3", "CONNECT", "CONNECTFREQ", "CYCLE_ON_HOST_CHANGE",
  "DEFAULT", "DEFAULT_FLOODCOUNT", "DEFAULT_FLOODTIME",
  "DEFAULT_SPLIT_SERVER_COUNT", "DEFAULT_SPLIT_USER_COUNT", "DEFER",
  "DENY", "DESCRIPTION", "DIE", "DISABLE_AUTH", "DISABLE_CHMODES",
  "DISABLE_FAKE_CHANNELS", "DISABLE_REMOTE_COMMANDS", "DNSBL",
  "DNSBL_EXEMPT", "DOTS_IN_IDENT", "DURATION", "EMAIL", "ENABLE_EXTBANS",
  "ENABLE_FORWARDING", "ENCRYPTED", "EXCEED_LIMIT", "EXEMPT",
  "FAILED_OPER_NOTICE", "FLATTEN_LINKS", "FLOOD_BURST", "FLOOD_LIMIT",
  "GECOS", "GENERAL", "GLINE", "GLINE_DURATION", "GLINE_ENABLE",
  "GLINE_EXEMPT", "GLINE_MIN_CIDR", "GLINE_MIN_CIDR6",
  "GLINE_REQUEST_DURATION", "HAVENT_READ_CONF", "HIDDEN", "HIDDEN_NAME",
  "HIDE_IDLE_FROM_OPERS", "HIDE_SERVER_IPS", "HIDE_SERVERS",
  "HIDE_SERVICES", "HIDE_SPOOF_IPS", "HOST", "HTTP", "HUB", "HUB_MASK",
  "IDENTITY", "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT", "INVITE_THROTTLE",
  "IP", "IRCD_AUTH", "IRCD_FLAGS", "IRCD_SID", "JOIN_FLOOD_COUNT",
  "JOIN_FLOOD_TIME", "KILL", "KILL_CHASE_TIME_LIMIT", "KLINE",
  "KLINE_EXEMPT", "KLINE_REASON", "KNOCK_DELAY", "KNOCK_DELAY_CHANNEL",
  "LEAF_MASK", "T_LINK", "LINKS_DELAY", "LISTEN", "MASK", "MATCH",
  "MAX_ACCEPT", "MAX_BANS", "MAX_CHANNELS", "MAX_CHANS_PER_USER",
  "MAX_GLOBAL", "MAX_IDLE", "MAX_LOCAL", "MAX_NICK_CHANGES",
  "MAX_NICK_LENGTH", "MAX_NICK_TIME", "MAX_NUMBER", "MAX_TARGETS",
  "MAX_TOPIC_LENGTH", "MAX_WATCH", "MIN_IDLE", "MIN_NONWILDCARD",
  "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "MOTD", "NAME",
  "NEED_ACCOUNT", "NEED_IDENT", "NEED_PASSWORD", "NETWORK_DESC",
  "NETWORK_NAME", "NICK", "NICK_COLLIDE_REALHOST", "NO_CREATE_ON_SPLIT",
  "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE", "NUMBER",
  "NUMBER_PER_CIDR", "NUMBER_PER_IP", "OPER_ONLY", "OPER_ONLY_UMODES",
  "OPER_PASS_RESV", "OPER_SNOMASKS", "OPER_UMODES", "OPERATOR",
  "OPERS_BYPASS_CALLERID", "PACE_WAIT", "PACE_WAIT_SIMPLE", "PASSWORD",
  "PATH", "PING_COOKIE", "PING_TIME", "PORT", "QSTRING", "QUIET_ON_BAN",
  "RANDOM_IDLE", "REASON", "REDIRPORT", "REDIRSERV", "REHASH", "REMOTE",
  "REMOTEBAN", "RESV", "RESV_EXEMPT", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS",
  "MONTHS", "YEARS", "SEND_PASSWORD", "SENDQ", "SERVERHIDE", "SERVERINFO",
  "SERVER_NAME", "SESSION", "SHORT_MOTD", "T_SNOMASKS", "SOFT_SENDQ",
  "SPOOF", "SPOOF_NOTICE", "SQUIT", "SSL_CERTIFICATE_FILE",
  "SSL_CERTIFICATE_FINGERPRINT", "SSL_CONNECTION_REQUIRED",
  "SSL_DH_ELLIPTIC_CURVE", "SSL_DH_PARAM_FILE",
  "SSL_MESSAGE_DIGEST_ALGORITHM", "SSLPROFILE", "SSL_PROFILE",
  "STATS_E_DISABLED", "STATS_I_OPER_ONLY", "STATS_K_OPER_ONLY",
  "STATS_M_OPER_ONLY", "STATS_O_OPER_ONLY", "STATS_P_OPER_ONLY",
  "STATS_U_OPER_ONLY", "T_ALIAS", "T_ALL", "T_BOTS", "T_CALLERID",
  "T_CCONN", "T_CLUSTER", "T_DEAF", "T_DEBUG", "T_DLINE", "T_FARCONNECT",
  "T_FILE", "T_FULL", "T_HIDECHANNELS", "T_GLOBOPS", "T_INVISIBLE",
  "T_IPV4", "T_IPV6", "T_LOCOPS", "T_LOG", "T_MAX_CLIENTS", "T_NCHANGE",
  "T_NOCTCP", "T_NONONREG", "T_OPERWALL", "T_RECVQ", "T_REJ", "T_RESTART",
  "T_SASL_NAME", "T_SERVER", "T_SERVICE", "T_SERVICES_NAME",
  "T_SERVNOTICE", "T_SET", "T_SHARED", "T_SIZE", "T_SKILL",
  "T_SOFTCALLERID", "T_SPY", "T_SSL", "T_UMODES", "T_UNAUTH", "T_UNDLINE",
  "T_UNLIMITED", "T_UNRESV", "T_UNXLINE", "T_WALLOP", "T_WALLOPS",
  "T_WALLUSERS", "T_WEBIRC", "TBOOL", "THROTTLE_NUM", "THROTTLE_TIME",
  "TKLINE_EXPIRE_NOTICES", "TMASKED", "MASS_HIGHLIGHT_NICKS",
  "TS_MAX_DELTA", "TS_WARN_DELTA", "TWODOTS", "TYPE", "UNKLINE",
  "USE_LOGGING", "USE_TARGET_CHANGE", "USER", "VHOST", "VHOST6",
  "WARN_NO_NLINE", "WLINE", "XLINE", "';'", "'}'", "'{'", "'='", "','",
  "':'", "$accept", "conf", "conf_item", "timespec_", "timespec",
  "sizespec_", "sizespec", "alias_entry", "$@1", "alias_items",
  "alias_item", "alias_name", "alias_user", "alias_host",
  "alias_oper_only", "modules_entry", "modules_items", "modules_item",
  "modules_module", "modules_path", "sslprofile", "$@2",
  "sslprofile_items", "sslprofile_item", "sslprofile_name",
  "sslprofile_dh_param_file", "sslprofile_dh_elliptic_curve",
  "sslprofile_cipher_list", "sslprofile_cafile", "sslprofile_identity",
  "$@3", "sslprofile_identity_items", "sslprofile_identity_item",
  "sslprofile_identity_server_name",
  "sslprofile_identity_rsa_private_key_file",
  "sslprofile_identity_certificate_file", "serverinfo_entry",
  "serverinfo_items", "serverinfo_item", "serverinfo_name",
  "serverinfo_sid", "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_max_nick_length",
  "serverinfo_max_topic_length", "serverinfo_hub", "admin_entry",
  "admin_items", "admin_item", "admin_name", "admin_email",
  "admin_description", "motd_entry", "$@4", "motd_items", "motd_item",
  "motd_mask", "motd_file", "dnsbl_entry", "$@5", "dnsbl_items",
  "dnsbl_item", "dnsbl_name", "dnsbl_reason", "dnsbl_matches",
  "match_items", "match_item", "cloak_entry", "$@6", "cloak_items",
  "cloak_item", "cloak_name", "cloak_default", "cloak_key", "cloak_key1",
  "cloak_key2", "cloak_key3", "logging_entry", "logging_items",
  "logging_item", "logging_use_logging", "logging_file_entry", "$@7",
  "logging_file_items", "logging_file_item", "logging_file_name",
  "logging_file_size", "logging_file_type", "$@8",
  "logging_file_type_items", "logging_file_type_item", "oper_entry", "$@9",
  "oper_items", "oper_item", "oper_name", "oper_user", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file",
  "oper_ssl_certificate_fingerprint", "oper_ssl_connection_required",
  "oper_class", "oper_umodes", "$@10", "oper_umodes_items",
  "oper_umodes_item", "oper_snomasks", "$@11", "oper_snomasks_items",
  "oper_snomasks_item", "oper_flags", "$@12", "oper_flags_items",
  "oper_flags_item", "class_entry", "$@13", "class_items", "class_item",
  "class_name", "class_ping_time", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_soft_sendq", "class_flood_burst",
  "class_flood_limit", "class_sendq", "class_recvq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_min_idle", "class_max_idle",
  "class_max_channels", "class_flags", "$@14", "class_flags_items",
  "class_flags_item", "listen_entry", "$@15", "listen_flags", "$@16",
  "listen_flags_items", "listen_flags_item", "listen_items", "listen_item",
  "listen_port", "$@17", "port_items", "port_item", "listen_address",
  "listen_host", "listen_ssl_profile", "auth_entry", "$@18", "auth_items",
  "auth_item", "auth_user", "auth_passwd", "auth_class", "auth_encrypted",
  "auth_flags", "$@19", "auth_flags_items", "auth_flags_item",
  "auth_spoof", "auth_redir_serv", "auth_redir_port",
  "auth_ssl_certificate_fingerprint", "auth_ca_file", "resv_entry", "$@20",
  "resv_items", "resv_item", "resv_mask", "resv_reason", "resv_exempt",
  "service_entry", "service_items", "service_item", "service_name",
  "shared_entry", "$@21", "shared_items", "shared_item", "shared_name",
  "shared_user", "shared_type", "$@22", "shared_types", "shared_type_item",
  "cluster_entry", "$@23", "cluster_items", "cluster_item", "cluster_name",
  "cluster_type", "$@24", "cluster_types", "cluster_type_item",
  "connect_entry", "$@25", "connect_items", "connect_item", "connect_name",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_ssl_certificate_fingerprint",
  "connect_ca_file", "connect_ssl_profile", "connect_port",
  "connect_aftype", "connect_flags", "$@26", "connect_flags_items",
  "connect_flags_item", "connect_encrypted", "connect_hub_mask",
  "connect_leaf_mask", "connect_class", "kill_entry", "$@27", "kill_items",
  "kill_item", "kill_user", "kill_reason", "deny_entry", "$@28",
  "deny_items", "deny_item", "deny_ip", "deny_reason", "exempt_entry",
  "exempt_items", "exempt_item", "exempt_ip", "gecos_entry", "$@29",
  "gecos_items", "gecos_item", "gecos_name", "gecos_reason",
  "general_entry", "general_items", "general_item", "general_max_watch",
  "general_cycle_on_host_change", "general_cloak_key",
  "general_account_whois", "general_gline_enable",
  "general_gline_duration", "general_gline_request_duration",
  "general_gline_min_cidr", "general_gline_min_cidr6",
  "general_kline_reason", "general_tkline_expire_notices",
  "general_kill_chase_time_limit", "general_hide_spoof_ips",
  "general_ignore_bogus_ts", "general_failed_oper_notice",
  "general_anti_nick_flood", "general_max_nick_time",
  "general_max_nick_changes", "general_max_accept",
  "general_anti_spam_exit_message_time", "general_ts_warn_delta",
  "general_ts_max_delta", "general_havent_read_conf",
  "general_invisible_on_connect", "general_warn_no_nline",
  "general_stats_e_disabled", "general_stats_o_oper_only",
  "general_stats_P_oper_only", "general_stats_u_oper_only",
  "general_stats_k_oper_only", "general_stats_i_oper_only",
  "general_stats_m_oper_only", "general_pace_wait",
  "general_caller_id_wait", "general_opers_bypass_callerid",
  "general_pace_wait_simple", "general_short_motd",
  "general_no_oper_flood", "general_oper_pass_resv",
  "general_dots_in_ident", "general_max_targets", "general_services_name",
  "general_sasl_name", "general_ping_cookie",
  "general_nick_collide_realhost", "general_disable_auth",
  "general_throttle_num", "general_throttle_time", "general_oper_umodes",
  "$@30", "general_enable_extbans", "general_enable_forwarding",
  "general_ssl_message_digest_algorithm", "general_mass_highlight_nicks",
  "umode_oitems", "umode_oitem", "general_oper_snomasks", "$@31",
  "snomask_oitems", "snomask_oitem", "general_oper_only_umodes", "$@32",
  "umode_items", "umode_item", "general_disable_chmodes",
  "general_use_target_change", "general_min_nonwildcard",
  "general_min_nonwildcard_simple", "general_default_floodcount",
  "general_default_floodtime", "channel_entry", "channel_items",
  "channel_item", "channel_disable_fake_channels", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_max_bans", "channel_default_split_user_count",
  "channel_default_split_server_count", "channel_no_create_on_split",
  "channel_no_join_on_split", "channel_jflood_count",
  "channel_jflood_time", "channel_quiet_on_ban", "channel_invite_throttle",
  "serverhide_entry", "serverhide_items", "serverhide_item",
  "serverhide_flatten_links", "serverhide_disable_remote_commands",
  "serverhide_hide_servers", "serverhide_hide_services",
  "serverhide_hidden_name", "serverhide_links_delay", "serverhide_hidden",
  "serverhide_hide_server_ips", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,    59,   125,   123,    61,    44,    58
};
# endif

#define YYPACT_NINF -853

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-853)))

#define YYTABLE_NINF -179

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -853,   720,  -853,  -240,  -258,  -230,  -853,  -853,  -853,  -853,
    -853,  -211,  -853,  -209,  -853,  -853,  -853,  -206,  -853,  -853,
    -853,  -187,  -184,  -853,  -853,  -853,  -172,  -169,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,     3,   880,  -159,
    -153,  -144,  -131,  -129,    11,   -99,   465,   -86,   -81,   -67,
     118,   -64,   -52,   -34,   758,   414,   -27,   -17,    -1,   130,
      26,    45,  -194,   -47,    46,    67,    40,  -853,  -853,  -853,
    -853,  -853,    71,    86,    98,   110,   113,   121,   131,   135,
     139,   140,   142,   145,   151,   175,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
     791,   477,   613,    60,   328,  -853,   152,    90,  -853,  -853,
     252,  -853,   153,   155,   156,   157,   159,   161,   162,   166,
     167,   168,   171,   172,   178,   184,   188,   190,   191,   192,
     193,   194,   196,   198,   201,   203,   207,   209,   215,   216,
     218,   221,   223,   224,   225,   227,  -853,   230,  -853,  -853,
     238,   241,   243,   253,   254,   256,   266,   268,   269,   273,
     279,   281,   283,   287,   288,   291,   293,   294,   295,   300,
     301,   302,   304,    36,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,   388,    52,   363,    15,
     306,   308,    51,  -853,  -853,  -853,    13,   466,    12,  -853,
     310,   312,   318,   321,   322,   323,   324,   326,   280,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,    80,   329,
     331,   332,   333,   342,   345,   350,   351,   353,   354,   355,
     182,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,   398,   116,    41,   106,   356,    58,  -853,
    -853,  -853,   177,  -853,   357,    89,  -853,  -853,   117,  -853,
     213,   267,   315,   141,  -853,   317,   384,   274,   415,   493,
     415,   415,   415,   496,   498,   386,   387,   390,   372,  -853,
     373,   371,   374,   377,   378,   380,  -853,   383,   385,   394,
     396,   397,   401,   402,   403,   404,   405,   409,   410,   411,
     138,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,   375,   412,   413,   417,   418,   420,   423,     9,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,   389,   425,   426,   427,
     428,   430,   432,   433,  -853,   435,   437,   441,   442,   443,
     447,   451,   197,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
     452,   461,    53,  -853,  -853,  -853,   468,   470,   471,   476,
     125,  -853,  -853,  -853,  -853,   595,   483,  -853,  -853,   482,
     485,    34,  -853,  -853,  -853,   505,   508,   415,   415,   607,
     512,   626,   628,   519,   616,   638,   527,   528,   529,   415,
     530,   646,   647,   415,   651,   539,   540,   541,   415,   642,
     655,   661,   415,   662,   664,   668,   672,   560,   565,   545,
     568,   548,   549,   574,   415,   415,   575,   576,   673,   578,
    -228,  -219,   581,   589,   590,   591,   688,   691,   709,   415,
     602,   718,   415,   415,   606,   608,   588,  -853,   604,   603,
     609,   610,  -853,   612,   619,   620,   621,   622,   623,   299,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,   627,   632,   102,  -853,  -853,  -853,   605,   635,
     637,  -853,   639,   643,  -853,   108,  -853,  -853,  -853,  -853,
    -853,  -853,   708,   722,   611,  -853,   650,   648,   656,    27,
    -853,  -853,  -853,   654,   669,   670,  -853,   674,   675,   676,
    -853,   677,   679,  -853,   680,   249,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,   684,   686,
     687,   689,    61,  -853,  -853,  -853,  -853,   694,   706,   712,
     724,   713,   714,   725,   415,   705,  -853,  -853,   731,   729,
     734,   777,   831,   827,   828,   829,   843,   830,   833,   727,
    -853,   728,   717,   721,  -853,   726,   732,   735,    10,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,   730,   736,   737,   743,
     745,   103,  -853,  -853,  -853,  -853,  -853,   750,   751,  -853,
      77,  -853,  -853,  -853,  -853,   741,   753,  -853,   723,   870,
     759,  -853,   762,   768,  -853,   770,    70,  -853,  -853,  -853,
    -853,   774,   776,   778,  -853,   784,   785,   786,   699,   787,
     790,   792,   793,   796,   797,   798,   799,   800,   801,  -853,
    -853,   920,   934,   415,   936,   937,   803,   939,   940,   415,
     941,   942,   415,   926,   944,   945,   415,   946,   946,   946,
     815,  -853,  -853,   931,   932,   933,   935,   838,   938,   821,
    -853,  -853,   943,  -166,   947,   948,   841,   949,   950,   822,
     951,   952,   956,   953,   954,   955,   957,   844,  -853,   958,
     960,   846,  -853,  -853,   962,   963,   964,   850,  -853,   851,
    -853,   967,   968,   854,  -853,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     871,   872,   873,   874,   875,   876,   877,   878,   879,   881,
     882,   883,   884,   885,   886,   887,   888,   889,   890,   788,
     891,   719,   814,   892,   893,   894,   895,   896,   897,   898,
     899,   900,   901,   902,   903,   904,   905,   906,   907,   908,
     909,   910,   911,   912,   913,   914,   915,   916,  -853,  -853,
     985,   995,   845,   824,  1032,   961,  1033,  1034,  1035,  1036,
     922,  -853,  1038,  1039,   925,  -853,  -853,  1041,  1042,   927,
     973,  1043,   929,  -853,   959,   965,  -853,  -853,  1046,  1047,
     966,  -853,  -853,  1048,   849,   969,  1049,  1050,  1051,   970,
    1052,   971,   972,  1053,   974,  -853,  -853,  1054,  1055,  1056,
     976,  -853,   977,   978,   979,   980,   981,   982,   983,   984,
    -853,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     996,   997,  -853,  -853,  1057,  1058,   998,  1059,  1060,  1061,
     999,  -853,  -853,  1062,   975,  1063,  1064,  1001,  -853,  -853,
    1065,  1000,  1002,  -853,  1004,  -853,   200,  1005,  -853,  -853,
    1066,  1003,  1068,  1007,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,   415,   415,   415,   415,   415,   415,   415,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    1008,  1009,  1010,  1011,  1012,   -46,  1013,  1014,  1015,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,     8,  1023,  1024,  1025,
    -853,  1026,  1027,  1028,  1029,  1030,  1031,  -853,  1037,  1040,
    1044,  1045,  1067,  1069,  1070,  1071,     0,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  -853,  1079,  1080,  -853,  -853,  -217,
    -853,  1081,  1082,  -853,  -853,  1083,  1084,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -199,  -853,  -853,  1085,  1086,  1087,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -196,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -191,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  1088,  1089,
    1093,   544,  1094,  1095,  1096,  1097,  1098,  1099,  -853,  1100,
    1101,  -853,  1102,  1103,   -18,   842,  1104,  -853,  1105,  -853,
    -853,  -853,  1106,  1107,  -853,  1109,  1110,   526,  1111,  1112,
    1113,   764,  1114,  1115,   826,  1116,  -853,  1117,  1118,  1119,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    1120,  1121,   240,  1122,  1123,  1124,  -853,  1125,  1126,  1127,
    1128,  -853,  1129,   645,  -853,  -853,  1130,  1131,  1132,  -853,
     127,  -853,  -853,  -853,  -853,  -853,  1133,   593,  1136,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -183,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,   946,   946,   946,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -175,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,   962,  -853,  -853,  -853,  -853,  -853,   788,  1140,
    1141,  1142,  -853,   719,  -853,   814,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -162,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -148,  -853,
    1090,   973,  1137,  -853,  -853,  -853,  -853,  -853,  -853,  1134,
    -853,  -853,  1135,  -853,  -853,  -853,  -853,  1138,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -126,  -853,  -853,  -853,  -853,  1139,  1143,  1144,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -106,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,    73,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  1145,  1147,  1148,  1149,   149,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,    75,  -853,
    -853,  1150,  -117,  1151,  1146,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,    88,
    -853,  -853,  -853,   -46,  -853,  -853,  -853,  -853,     0,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,   544,  -853,   -18,
    -853,  -853,  -853,  1154,  1155,  1156,  -853,   526,  1157,  1158,
    1159,  -853,   764,  -853,   826,  -853,  1153,  1167,  1168,  1160,
    -853,  -853,   645,  1161,  1162,  1163,   640,  -853,  -853,   593,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  1164,  1165,  1166,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
      95,  -853,  -853,  -853,  -853,  -853,  -853,   640,  -853
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   291,   154,   472,   522,
     140,     0,   537,     0,   367,   513,   339,     0,   131,   202,
     407,     0,     0,    68,    47,   450,     0,     0,   424,     3,
       5,    24,    25,    12,     4,    26,    27,    28,     6,     7,
       9,    10,    11,    14,    15,    16,    17,    18,    19,    20,
      21,    23,    22,     8,    13,    29,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   123,   124,   126,
     125,   736,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   722,   733,   724,   725,
     726,   723,   727,   728,   729,   730,   731,   732,   734,   735,
       0,     0,     0,     0,     0,   535,     0,     0,   533,   534,
       0,   610,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   698,     0,   681,   661,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   548,   598,   601,   602,   603,   591,
     592,   593,   594,   595,   596,   590,   559,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   586,   560,   561,
     597,   563,   569,   570,   564,   566,   567,   565,   578,   579,
     568,   571,   572,   573,   562,   575,   599,   600,   587,   588,
     589,   584,   585,   576,   606,   607,   608,   609,   577,   574,
     604,   605,   582,   583,   580,   581,     0,     0,     0,     0,
       0,     0,     0,    62,    63,    64,     0,     0,     0,   761,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   752,
     753,   754,   755,   756,   759,   757,   758,   760,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    97,    98,   108,   101,   102,   103,    99,   107,   104,
     105,   106,   100,     0,     0,     0,     0,     0,     0,   173,
     174,   175,     0,   422,     0,     0,   420,   421,     0,   127,
       0,     0,     0,     0,   122,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   721,
       0,     0,     0,     0,     0,     0,   333,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   294,   295,   298,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   296,   297,   299,   310,   311,   312,
     313,     0,     0,     0,     0,     0,     0,     0,     0,   157,
     158,   159,   160,   161,   162,   163,     0,     0,     0,     0,
       0,     0,     0,     0,   503,     0,     0,     0,     0,     0,
       0,     0,     0,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   485,   484,   486,   490,   487,   488,   489,   528,
       0,     0,     0,   525,   526,   527,     0,     0,     0,     0,
       0,   143,   144,   145,   146,     0,     0,   532,   543,     0,
       0,     0,   540,   541,   542,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   547,     0,     0,
       0,     0,   386,     0,     0,     0,     0,     0,     0,     0,
     370,   371,   372,   373,   378,   374,   375,   376,   377,   379,
     380,   519,     0,     0,     0,   516,   517,   518,     0,     0,
       0,   341,     0,     0,   353,     0,   351,   352,   354,   355,
     356,    65,     0,     0,     0,    61,     0,     0,     0,     0,
     134,   135,   136,     0,     0,     0,   260,     0,     0,     0,
     243,     0,     0,   226,     0,     0,   205,   206,   207,   208,
     212,   213,   214,   215,   211,   209,   210,   216,     0,     0,
       0,     0,     0,   410,   411,   412,   413,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   751,   109,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      96,     0,     0,     0,    84,     0,     0,     0,     0,    71,
      72,    73,    74,    75,    76,    77,     0,     0,     0,     0,
       0,     0,    50,    51,    52,    53,    54,     0,     0,   458,
       0,   453,   454,   455,   176,     0,     0,   172,     0,     0,
       0,   419,     0,     0,   434,     0,     0,   427,   428,   429,
     430,     0,     0,     0,   121,     0,     0,     0,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   720,
     314,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   293,   164,     0,     0,     0,     0,     0,     0,     0,
     156,   491,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   474,     0,
       0,     0,   524,   147,     0,     0,     0,     0,   142,     0,
     531,     0,     0,     0,   539,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   546,   381,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   369,     0,     0,     0,   515,   357,     0,     0,     0,
       0,     0,     0,   350,     0,     0,    60,   137,     0,     0,
       0,   133,   217,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   204,   414,     0,     0,     0,
       0,   409,     0,     0,     0,     0,     0,     0,     0,     0,
     750,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    95,    78,     0,     0,     0,     0,     0,     0,
       0,    70,    55,     0,     0,     0,     0,     0,    49,   456,
       0,     0,     0,   452,     0,   171,     0,     0,   418,   431,
       0,     0,     0,     0,   426,   130,   129,   128,   743,   742,
     737,    31,    31,    31,    31,    31,    31,    31,    33,    32,
     749,   746,   747,   738,   739,   741,   740,   744,   745,   748,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,     0,     0,     0,
     292,     0,     0,     0,     0,     0,     0,   155,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   473,     0,     0,   523,   153,     0,
     152,     0,     0,   141,   536,     0,     0,   538,   614,   626,
     630,   646,   613,   612,   718,   719,   658,   714,   652,   663,
     664,   625,   616,   615,   618,   619,   617,   633,   623,   624,
     634,   622,   620,   629,   628,   627,   653,   611,   716,   717,
     657,   650,   710,   703,   704,   707,   711,   702,   712,   705,
     706,   709,   713,   708,     0,   701,   651,   697,   686,   688,
     689,   691,   690,   693,   692,   695,   694,     0,   684,   677,
     670,   671,   674,   678,   669,   679,   672,   673,   676,   680,
     675,     0,   668,   647,   645,   648,   656,   649,   665,   636,
     642,   643,   640,   641,   644,   637,   638,   639,   655,   654,
     659,   660,   621,   666,   632,   631,   715,   635,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   368,     0,
       0,   514,     0,     0,     0,   362,   358,   361,     0,   340,
      66,    67,     0,     0,   132,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   230,     0,   203,     0,     0,     0,
     408,   763,   762,   768,   766,   769,   764,   765,   767,   112,
     120,   111,   118,   119,   110,   114,   113,   117,   115,   116,
       0,     0,     0,     0,     0,     0,    69,     0,     0,     0,
       0,    48,     0,     0,   451,   177,     0,     0,     0,   189,
       0,   181,   182,   184,   183,   423,     0,     0,     0,   425,
      34,    35,    36,    37,    38,    39,    40,   327,   328,   318,
     323,   324,   338,   337,     0,   336,   332,   320,   331,   321,
     319,   330,   315,   329,   317,   316,    41,    41,    41,    43,
      42,   325,   322,   326,   167,   168,   169,   170,   166,   165,
     496,   501,   502,   498,   512,   509,   493,   510,   507,   508,
       0,   506,   511,   492,   500,   495,   497,   499,   494,   529,
     530,   150,     0,   148,   149,   544,   545,   699,     0,     0,
       0,     0,   682,     0,   662,     0,   406,   384,   385,   395,
     393,   391,   397,   392,   400,   394,   401,   396,   398,   390,
     399,     0,   389,   383,   404,   403,   402,   405,   382,   521,
     520,   365,   364,   349,   346,   348,   347,   345,     0,   344,
       0,     0,     0,   366,   138,   139,   225,   221,   282,   269,
     279,   278,   267,   272,   290,   281,   288,   271,   274,   265,
     284,   287,   266,   283,   280,   289,   275,   277,   285,   286,
     273,   276,     0,   263,   218,   220,   222,   259,   248,   250,
     251,   252,   254,   255,   253,   257,   256,     0,   246,   223,
     224,   239,   232,   233,   236,   240,   231,   241,   234,   235,
     238,   242,   237,     0,   229,   219,   417,   415,   416,    83,
      82,     0,     0,     0,     0,     0,    87,    88,    89,    90,
      79,    81,    80,    56,    59,    58,    57,   457,   462,   468,
     471,   464,   470,   465,   469,   467,   463,   466,     0,   461,
     185,     0,     0,     0,     0,   180,   432,   438,   444,   447,
     449,   440,   446,   441,   445,   443,   439,   448,   442,     0,
     437,   433,   334,     0,    44,    45,    46,   504,     0,   151,
     700,   696,   685,   687,   683,   667,   387,     0,   342,     0,
     363,   360,   359,     0,     0,     0,   261,     0,     0,     0,
       0,   244,     0,   227,   230,    91,     0,     0,     0,     0,
      86,   459,     0,     0,     0,     0,     0,   179,   435,     0,
     335,   505,   388,   343,   268,   264,   270,   262,   258,   247,
     249,   245,   228,     0,     0,     0,    85,   460,   186,   188,
     187,   195,   200,   199,   194,   197,   201,   198,   193,   196,
       0,   192,   436,    93,    92,    94,   190,     0,   191
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -853,  -853,  -853,   -24,  -335,  -852,  -727,  -853,  -853,  -853,
     557,  -853,  -853,  -853,  -853,  -853,  -853,  1169,  -853,  -853,
    -853,  -853,  -853,   571,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -181,  -853,  -853,  -853,  -853,  -853,   921,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  1173,  -853,  -853,  -853,  -853,  -853,  -853,   649,
    -853,  -853,  -853,  -853,  -853,   775,  -853,  -853,  -853,  -853,
     -56,  -853,  -853,  -853,   834,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,   917,  -853,  -853,  -853,  -853,    17,  -853,
    -853,  -853,  -853,  -853,  -306,  -853,  -853,  -853,   667,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -251,  -853,  -853,  -853,  -248,  -853,  -853,  -853,  -177,  -853,
    -853,  -853,  1091,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -204,  -853,  -853,  -853,  -853,  -853,
    -164,  -853,   738,  -853,  -853,  -853,   -25,  -853,  -853,  -853,
    -853,  -853,  -853,   779,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -160,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
     707,  -853,  -853,  -853,  -853,  -853,  1092,  -853,  -853,  -853,
    -853,   634,  -853,  -853,  -853,  -853,  -853,  -178,  -853,  -853,
    -853,   652,  -853,  -853,  -853,  -853,  -168,  -853,  -853,  -853,
     928,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -135,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,   771,  -853,  -853,  -853,  -853,  -853,  1006,  -853,
    -853,  -853,  -853,  1199,  -853,  -853,  -853,  -853,  1108,  -853,
    -853,  -853,  -853,  1175,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,    32,
    -853,  -853,  -853,    35,  -853,  -853,  -853,    42,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  1224,  -853,  -853,  -853,
    -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853,  -853,  1171,  -853,  -853,  -853,  -853,  -853,  -853,  -853,
    -853
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    29,   958,   959,  1249,  1250,    30,    77,   661,
     662,   663,   664,   665,   666,    31,   262,   263,   264,   265,
      32,    76,   648,   649,   650,   651,   652,   653,   654,   655,
     916,  1405,  1406,  1407,  1408,  1409,    33,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
      34,    86,    87,    88,    89,    90,    35,    71,   579,   580,
     581,   582,    36,    63,   450,   451,   452,   453,   454,  1019,
    1020,    37,    60,   398,   399,   400,   401,   402,   403,   404,
     405,    38,   318,   319,   320,   321,   322,  1210,  1211,  1212,
    1213,  1214,  1433,  1530,  1531,    39,    72,   595,   596,   597,
     598,   599,   600,   601,   602,   603,   604,   605,   882,  1393,
    1394,   606,   879,  1377,  1378,   607,   875,  1362,  1363,    40,
      59,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   716,  1234,  1235,    41,    69,   564,   859,  1328,
    1329,   565,   566,   567,  1332,  1146,  1147,   568,   569,   570,
      42,    67,   539,   540,   541,   542,   543,   544,   545,   843,
    1311,  1312,   546,   547,   548,   549,   550,    43,    73,   612,
     613,   614,   615,   616,    44,   325,   326,   327,    45,    81,
     686,   687,   688,   689,   690,   941,  1449,  1450,    46,    78,
     670,   671,   672,   673,   931,  1428,  1429,    47,    61,   422,
     423,   424,   425,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   749,  1270,  1271,   435,   436,   437,   438,    48,
      68,   554,   555,   556,   557,    49,    62,   442,   443,   444,
     445,    50,   127,   128,   129,    51,    65,   461,   462,   463,
     464,    52,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   502,   244,   245,   246,   247,  1101,  1102,
     248,   501,  1087,  1088,   249,   499,  1074,  1075,   250,   251,
     252,   253,   254,   255,    53,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      54,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     987,   988,   989,   699,    82,   701,   702,   703,    57,  1268,
     391,   641,   125,   608,   576,   986,  1323,   820,  1246,  1247,
    1248,   821,  1232,   642,    55,    56,   822,   323,   576,   643,
     823,   392,   393,   394,   395,   458,    58,   131,   396,    83,
     132,    82,   667,   133,   134,   999,  1000,  1281,  1324,    84,
     135,  1282,   259,   551,   439,    64,  1325,    66,   136,   316,
      70,   439,   608,   609,   137,  1287,   138,   139,  1292,  1288,
     329,   682,  1293,  1294,   140,   141,    83,  1295,   667,    74,
     142,  1452,    75,   143,   144,  1453,    84,   644,   145,  1457,
     323,   125,   126,  1458,    79,   146,   147,    80,   148,   149,
     150,   151,  1466,   551,   656,  1233,  1467,   120,   152,   558,
     610,   577,   609,   121,   153,   154,  1468,   656,   682,   259,
    1469,  1494,   122,    85,   155,   577,   446,   156,  1206,   397,
     645,   316,   777,   778,   440,   123,   157,   124,  1476,   350,
     986,   440,  1477,   158,   789,   159,   324,   160,   793,   161,
    1401,   162,   163,   798,   459,   351,   352,   802,  1481,   610,
      85,   668,  1482,   164,   611,   353,   165,   130,   260,   814,
     815,   126,   166,   167,   168,   169,    91,   170,   171,   172,
     256,   559,   173,   288,   831,   257,   460,   834,   835,   560,
     683,   561,   354,   355,   646,   647,   261,   668,   406,   258,
     407,  1206,   266,   408,   552,   441,  1326,    92,    93,   324,
     409,   174,   441,   611,   267,    94,  1327,   410,   289,   578,
     330,   356,   175,   657,   447,   176,   177,   178,   179,   180,
     181,   182,   268,   578,  1269,   260,   657,   683,   658,   313,
     357,  1401,   358,   359,   360,   448,   411,  1207,   361,   314,
     583,   658,   362,   458,   552,    95,   562,   290,   363,   183,
      96,    97,   184,   261,  -178,   315,   291,    98,    99,   584,
     412,   364,   365,   413,   739,   920,   100,   449,   101,   571,
     414,   269,   185,   186,   187,   366,   188,   189,   190,   899,
     292,   415,   870,   191,   293,   669,   563,   192,   585,   773,
     528,   526,   294,   102,   103,   333,   295,   296,   367,  1402,
     553,   328,   529,   331,   317,   368,   574,   416,   761,   530,
    1207,   270,  1403,   676,   684,   104,   890,   659,   685,   446,
    1404,   669,   586,   271,   332,   943,  -178,  1483,   335,  1491,
     659,  1484,   932,  1492,   627,   417,   272,   273,   531,   274,
     275,   276,  1498,   336,   680,   456,  1499,  1208,   369,  1536,
     553,   660,   691,  1537,   558,   337,   418,   854,   927,   587,
     674,   684,   459,   862,   660,   685,   277,   338,   972,   419,
     339,  1209,   532,   678,   978,   420,   317,   981,   340,   528,
     767,   985,  1434,   588,  1454,  1455,  1456,   297,   341,   641,
    1402,   529,   342,   730,   460,   694,   343,   344,   530,   345,
     589,   642,   346,  1403,  1489,   288,   692,   643,   347,   455,
     465,  1404,   466,   467,   468,   590,   469,   447,   470,   471,
    1208,   591,   592,   472,   473,   474,   559,   531,   475,   476,
     348,   298,   299,   533,   560,   477,   561,   639,   448,   695,
     289,   478,   534,   535,  1209,   479,   421,   480,   481,   482,
     483,   484,   757,   485,   693,   486,   131,   583,   487,   132,
     488,   532,   133,   134,   489,   644,   490,   536,   391,   135,
     449,   537,   491,   492,   593,   493,   584,   136,   494,   290,
     495,   496,   497,   137,   498,   138,   139,   500,   291,   392,
     393,   394,   395,   140,   141,   503,   396,   594,   504,   142,
     505,   562,   143,   144,   884,   585,   696,   145,   645,   697,
     506,   507,   292,   508,   146,   147,   293,   148,   149,   150,
     151,  1338,   533,   509,   294,   510,   511,   152,   295,   296,
     512,   534,   535,   153,   154,   625,   513,   698,   514,   586,
     515,   563,  1339,   155,   516,   517,   156,   538,   518,  1299,
     519,   520,   521,  1340,   850,   157,   536,   522,   523,   524,
     537,   525,   158,   572,   159,   573,   160,   617,   161,   618,
     162,   163,   646,   647,  1341,   619,   587,  1300,   620,   621,
     622,   623,   164,   624,  1301,   165,   628,   397,   629,   630,
     631,   166,   167,   168,   169,  1302,   170,   171,   172,   632,
     588,   173,   633,  1342,   406,  1343,   407,   634,   635,   408,
     636,   637,   638,   675,   679,   700,   409,   589,   704,   297,
     705,   706,   707,   410,  1303,   708,   709,   710,   711,   732,
     174,   712,   590,  1344,   713,   714,   538,   715,   591,   592,
     717,   175,   718,   741,   176,   177,   178,   179,   180,   181,
     182,   719,   411,   720,   721,  1304,  1305,  1306,   722,   723,
     724,   725,   726,   298,   299,  1307,   727,   728,   729,   733,
     734,  1345,  1437,  1346,   735,   736,   412,   737,   183,   413,
     738,   184,   742,   743,   744,   745,   414,   746,  1521,   747,
     748,   593,   750,  1308,   751,  1495,  1347,   415,   752,   753,
     754,   185,   186,   187,   755,   188,   189,   190,   756,   759,
       2,     3,   191,  1309,   594,     4,   192,  1522,   760,  1523,
    1348,  1349,   763,   416,  1418,  1350,     5,   764,   765,  1351,
       6,     7,  1352,   766,   769,  1353,     8,   770,  1354,   771,
     775,  1438,   772,   776,  1355,     9,   779,   780,   781,   269,
     782,   417,    10,  1356,   783,   784,  1357,  1439,  1358,  1359,
     785,    11,   786,   787,   788,   790,    12,    13,   791,   792,
    1524,  1360,   418,   794,   795,   796,   797,   800,  1310,  1361,
    1440,   799,   350,   801,   803,   419,   804,  1441,  1525,   270,
     805,   420,    14,  1419,   806,   807,  1442,    15,   351,   352,
     808,   271,   809,   810,  1077,   811,   812,    16,   353,   813,
     816,   817,   818,   819,   272,   273,   824,   274,   275,   276,
    1443,   698,  1444,  1445,   825,   826,   827,   828,    17,    18,
     829,   830,  1420,  1526,  1527,   354,   355,   832,  1446,  1421,
     833,   836,   838,   837,   277,  1447,  1448,   864,  1422,  1367,
      19,   951,   952,   953,   954,   955,   956,   957,   839,   856,
     840,   865,   421,   895,   356,   866,   841,   842,    20,   844,
     901,    91,  1423,   903,  1424,  1425,   845,   846,   847,   848,
     849,    21,    22,   357,   852,   358,   359,   360,  1528,   853,
    1426,   361,   857,  1529,   858,   362,   860,    23,  1427,   904,
     861,   363,    92,    93,   867,   868,    24,  1078,   872,  1079,
      94,    25,  1080,   869,   364,   365,  1081,  1220,  1221,  1222,
    1223,  1224,  1225,  1226,    26,  1082,   873,   874,   366,   892,
    1083,   876,   877,   878,   880,    27,   881,   883,   886,    28,
    1084,   893,  1085,   887,   888,  1086,   889,   894,   896,   897,
      95,   367,  1368,   905,  1369,    96,    97,  1370,   368,   900,
     898,  1371,    98,    99,   902,   909,   906,   907,   908,   910,
    1372,   100,   911,   101,   914,  1373,   934,  1062,   915,   936,
    1063,   912,   913,   917,   922,  1374,  1064,  1375,  1065,   918,
    1376,  1066,   919,   923,   924,  1067,  1068,  1069,   102,   103,
     925,   369,   926,  1089,   929,  1070,  1090,   935,   930,   937,
    1071,  1072,  1091,   938,  1092,  1381,   939,  1093,  1382,  1073,
     104,  1094,  1095,  1096,  1383,   940,  1384,   942,   945,  1385,
     946,  1097,   947,  1386,  1387,  1388,  1098,  1099,   948,   949,
     950,   960,   970,  1389,   961,  1100,   962,   963,  1390,  1391,
     964,   965,   966,   967,   968,   969,   971,  1392,   973,   974,
     975,   976,   977,   979,   980,   982,   983,   984,   986,   990,
     991,   992,   993,   995,   994,   997,  1003,   996,  1009,  1006,
    1130,  1131,   998,  1133,  1156,  1330,  1001,  1002,  1004,  1005,
    1007,  1008,  1010,  1011,  1012,  1145,  1013,  1015,  1014,  1016,
    1017,  1018,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1128,  1043,  1044,  1045,  1046,  1047,
    1048,  1049,  1050,  1051,  1129,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1076,  1103,  1104,  1105,  1106,
    1107,  1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,
    1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,
    1127,  1132,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,  1148,  1149,  1144,  1152,  1153,  1155,  1158,  1159,
    1160,  1162,  1165,  1167,  1168,  1169,  1190,  1191,  1193,  1194,
    1195,  1197,  1199,  1200,  1202,  1216,  1163,  1218,   928,   921,
    1198,   640,  1470,  1150,  1490,   768,  1459,  1435,   871,  1151,
    1154,  1538,   740,  1512,  1511,   677,  1157,  1161,  1166,  1164,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1500,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,   334,
    1188,  1189,   885,  1196,  1192,  1201,  1204,  1203,  1205,  1215,
    1217,  1219,  1227,  1228,  1229,  1230,  1231,  1236,  1237,  1238,
    1239,  1240,  1241,  1242,  1243,  1244,  1245,  1251,  1252,  1253,
    1254,  1255,  1256,  1257,  1258,  1259,  1461,  1462,  1463,  1493,
    1507,  1260,  1513,   863,  1261,  1503,  1471,  1502,  1262,  1263,
    1504,  1505,  1506,  1508,  1509,  1510,  1514,  1515,   851,   891,
     944,  1532,   933,  1501,  1517,   855,   457,  1465,  1464,   349,
    1460,  1264,     0,  1265,  1266,  1267,  1272,  1273,  1274,  1275,
    1276,  1277,  1278,  1279,  1280,  1283,  1284,  1285,  1286,     0,
     758,     0,  1296,  1297,  1289,  1290,  1291,  1298,  1313,  1314,
    1315,  1316,  1317,  1318,  1319,  1320,  1321,  1322,   527,  1333,
    1334,  1335,  1331,  1336,  1337,  1364,  1365,  1366,  1379,  1380,
    1395,  1396,  1397,  1398,  1399,  1400,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,  1417,  1430,     0,     0,  1436,  1431,  1432,
    1451,  1472,     0,  1473,  1474,     0,     0,  1475,  1478,  1485,
    1497,     0,  1479,  1480,  1486,  1487,  1488,   681,  1496,     0,
       0,     0,     0,     0,  1516,  1518,  1519,  1520,  1533,  1534,
    1535,   575,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   762,   626,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   731,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   774
};

static const yytype_int16 yycheck[] =
{
     727,   728,   729,   338,     1,   340,   341,   342,   266,     9,
       1,     1,     1,     1,     1,   132,    34,   245,    10,    11,
      12,   249,    68,    13,   264,   265,   245,     1,     1,    19,
     249,    22,    23,    24,    25,     1,   266,     1,    29,    36,
       4,     1,     1,     7,     8,   211,   212,   264,    66,    46,
      14,   268,     1,     1,     1,   266,    74,   266,    22,     1,
     266,     1,     1,    51,    28,   264,    30,    31,   264,   268,
     264,     1,   268,   264,    38,    39,    36,   268,     1,   266,
      44,   264,   266,    47,    48,   268,    46,    77,    52,   264,
       1,     1,    81,   268,   266,    59,    60,   266,    62,    63,
      64,    65,   264,     1,     1,   151,   268,   266,    72,     1,
      98,    98,    51,   266,    78,    79,   264,     1,     1,     1,
     268,   238,   266,   120,    88,    98,     1,    91,     1,   120,
     120,     1,   467,   468,    81,   266,   100,   266,   264,     1,
     132,    81,   268,   107,   479,   109,   120,   111,   483,   113,
       1,   115,   116,   488,   120,    17,    18,   492,   264,    98,
     120,   120,   268,   127,   152,    27,   130,   266,   117,   504,
     505,    81,   136,   137,   138,   139,     1,   141,   142,   143,
     266,    73,   146,     1,   519,   266,   152,   522,   523,    81,
     120,    83,    54,    55,   184,   185,   145,   120,     1,   266,
       3,     1,   266,     6,   152,   152,   224,    32,    33,   120,
      13,   175,   152,   152,   266,    40,   234,    20,    36,   206,
     267,    83,   186,   120,    99,   189,   190,   191,   192,   193,
     194,   195,   266,   206,   234,   117,   120,   120,   135,   266,
     102,     1,   104,   105,   106,   120,    49,   120,   110,   266,
       1,   135,   114,     1,   152,    80,   148,    75,   120,   223,
      85,    86,   226,   145,   206,   266,    84,    92,    93,    20,
      73,   133,   134,    76,   265,   265,   101,   152,   103,   264,
      83,     1,   246,   247,   248,   147,   250,   251,   252,   624,
     108,    94,   265,   257,   112,   254,   188,   261,    49,   265,
       1,   265,   120,   128,   129,   265,   124,   125,   170,   160,
     258,   266,    13,   267,   256,   177,   265,   120,   265,    20,
     120,    41,   173,   265,   254,   150,   265,   224,   258,     1,
     181,   254,    83,    53,   267,   265,   206,   264,   267,   264,
     224,   268,   265,   268,   264,   148,    66,    67,    49,    69,
      70,    71,   264,   267,   265,   265,   268,   230,   220,   264,
     258,   258,   149,   268,     1,   267,   169,   265,   265,   120,
     264,   254,   120,   265,   258,   258,    96,   267,   713,   182,
     267,   254,    83,   206,   719,   188,   256,   722,   267,     1,
     265,   726,   265,   144,  1246,  1247,  1248,   215,   267,     1,
     160,    13,   267,   265,   152,   264,   267,   267,    20,   267,
     161,    13,   267,   173,   265,     1,   149,    19,   267,   267,
     267,   181,   267,   267,   267,   176,   267,    99,   267,   267,
     230,   182,   183,   267,   267,   267,    73,    49,   267,   267,
     265,   259,   260,   144,    81,   267,    83,   265,   120,   132,
      36,   267,   153,   154,   254,   267,   259,   267,   267,   267,
     267,   267,   265,   267,   149,   267,     1,     1,   267,     4,
     267,    83,     7,     8,   267,    77,   267,   178,     1,    14,
     152,   182,   267,   267,   235,   267,    20,    22,   267,    75,
     267,   267,   267,    28,   267,    30,    31,   267,    84,    22,
      23,    24,    25,    38,    39,   267,    29,   258,   267,    44,
     267,   148,    47,    48,   265,    49,   132,    52,   120,   245,
     267,   267,   108,   267,    59,    60,   112,    62,    63,    64,
      65,     5,   144,   267,   120,   267,   267,    72,   124,   125,
     267,   153,   154,    78,    79,   265,   267,   132,   267,    83,
     267,   188,    26,    88,   267,   267,    91,   258,   267,    15,
     267,   267,   267,    37,   265,   100,   178,   267,   267,   267,
     182,   267,   107,   267,   109,   267,   111,   267,   113,   267,
     115,   116,   184,   185,    58,   267,   120,    43,   267,   267,
     267,   267,   127,   267,    50,   130,   267,   120,   267,   267,
     267,   136,   137,   138,   139,    61,   141,   142,   143,   267,
     144,   146,   267,    87,     1,    89,     3,   267,   267,     6,
     267,   267,   267,   267,   267,   132,    13,   161,   132,   215,
     132,   245,   245,    20,    90,   245,   264,   264,   267,   264,
     175,   267,   176,   117,   267,   267,   258,   267,   182,   183,
     267,   186,   267,   264,   189,   190,   191,   192,   193,   194,
     195,   267,    49,   267,   267,   121,   122,   123,   267,   267,
     267,   267,   267,   259,   260,   131,   267,   267,   267,   267,
     267,   155,    89,   157,   267,   267,    73,   267,   223,    76,
     267,   226,   267,   267,   267,   267,    83,   267,    58,   267,
     267,   235,   267,   159,   267,  1432,   180,    94,   267,   267,
     267,   246,   247,   248,   267,   250,   251,   252,   267,   267,
       0,     1,   257,   179,   258,     5,   261,    87,   267,    89,
     204,   205,   264,   120,    89,   209,    16,   267,   267,   213,
      20,    21,   216,   267,   149,   219,    26,   264,   222,   267,
     245,   158,   267,   245,   228,    35,   149,   245,   132,     1,
     132,   148,    42,   237,   245,   149,   240,   174,   242,   243,
     132,    51,   245,   245,   245,   245,    56,    57,   132,   132,
     140,   255,   169,   132,   245,   245,   245,   132,   244,   263,
     197,   149,     1,   132,   132,   182,   132,   204,   158,    41,
     132,   188,    82,   158,   132,   245,   213,    87,    17,    18,
     245,    53,   267,   245,    95,   267,   267,    97,    27,   245,
     245,   245,   149,   245,    66,    67,   245,    69,    70,    71,
     237,   132,   239,   240,   245,   245,   245,   149,   118,   119,
     149,   132,   197,   203,   204,    54,    55,   245,   255,   204,
     132,   245,   264,   245,    96,   262,   263,   149,   213,    95,
     140,   162,   163,   164,   165,   166,   167,   168,   264,   264,
     267,   149,   259,   149,    83,   264,   267,   267,   158,   267,
     149,     1,   237,   149,   239,   240,   267,   267,   267,   267,
     267,   171,   172,   102,   267,   104,   105,   106,   258,   267,
     255,   110,   267,   263,   267,   114,   267,   187,   263,   132,
     267,   120,    32,    33,   264,   267,   196,   198,   264,   200,
      40,   201,   203,   267,   133,   134,   207,   951,   952,   953,
     954,   955,   956,   957,   214,   216,   267,   267,   147,   245,
     221,   267,   267,   267,   267,   225,   267,   267,   264,   229,
     231,   245,   233,   267,   267,   236,   267,   245,   245,   245,
      80,   170,   198,   132,   200,    85,    86,   203,   177,   264,
     245,   207,    92,    93,   245,   132,   149,   149,   149,   149,
     216,   101,   149,   103,   267,   221,   245,   199,   267,   266,
     202,   264,   264,   267,   264,   231,   208,   233,   210,   267,
     236,   213,   267,   267,   267,   217,   218,   219,   128,   129,
     267,   220,   267,   199,   264,   227,   202,   264,   267,   149,
     232,   233,   208,   264,   210,   199,   264,   213,   202,   241,
     150,   217,   218,   219,   208,   267,   210,   267,   264,   213,
     264,   227,   264,   217,   218,   219,   232,   233,   264,   264,
     264,   264,   132,   227,   264,   241,   264,   264,   232,   233,
     264,   264,   264,   264,   264,   264,   132,   241,   132,   132,
     267,   132,   132,   132,   132,   149,   132,   132,   132,   264,
     149,   149,   149,   245,   149,   264,   245,   149,   132,   267,
     245,   267,   149,   132,   245,   253,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   132,   149,   149,   264,   149,
     264,   149,   149,   149,   264,   264,   149,   149,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   149,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   149,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   149,   149,   149,   149,   149,   264,   149,   149,   264,
     149,   149,   149,   264,   267,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   245,   149,   661,   648,
     245,   300,   132,   264,  1405,   450,  1282,  1210,   579,   264,
     264,  1537,   398,  1484,  1482,   318,   267,   267,   264,   267,
     264,   264,   264,   264,   264,   264,   264,   264,   264,  1453,
     264,   264,   264,   264,   264,   264,   264,   264,   264,    86,
     264,   264,   595,   264,   266,   264,   264,   267,   264,   264,
     267,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   156,   156,   156,   149,
    1477,   264,   149,   565,   264,  1469,  1331,  1467,   264,   264,
     156,   156,   156,   156,   156,   156,   149,   149,   539,   612,
     686,  1499,   670,  1458,  1492,   554,   127,  1295,  1293,   105,
    1288,   264,    -1,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,    -1,
     422,    -1,   264,   264,   269,   269,   269,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   193,   264,
     264,   264,   268,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,    -1,    -1,   264,   267,   267,
     264,   264,    -1,   269,   269,    -1,    -1,   269,   269,   264,
     264,    -1,   269,   269,   267,   267,   267,   325,   267,    -1,
      -1,    -1,    -1,    -1,   264,   264,   264,   264,   264,   264,
     264,   262,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   442,   278,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   461
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   271,     0,     1,     5,    16,    20,    21,    26,    35,
      42,    51,    56,    57,    82,    87,    97,   118,   119,   140,
     158,   171,   172,   187,   196,   201,   214,   225,   229,   272,
     277,   285,   290,   306,   320,   326,   332,   341,   351,   365,
     389,   415,   430,   447,   454,   458,   468,   477,   499,   505,
     511,   515,   521,   594,   610,   264,   265,   266,   266,   390,
     342,   478,   506,   333,   266,   516,   266,   431,   500,   416,
     266,   327,   366,   448,   266,   266,   291,   278,   469,   266,
     266,   459,     1,    36,    46,   120,   321,   322,   323,   324,
     325,     1,    32,    33,    40,    80,    85,    86,    92,    93,
     101,   103,   128,   129,   150,   595,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     266,   266,   266,   266,   266,     1,    81,   512,   513,   514,
     266,     1,     4,     7,     8,    14,    22,    28,    30,    31,
      38,    39,    44,    47,    48,    52,    59,    60,    62,    63,
      64,    65,    72,    78,    79,    88,    91,   100,   107,   109,
     111,   113,   115,   116,   127,   130,   136,   137,   138,   139,
     141,   142,   143,   146,   175,   186,   189,   190,   191,   192,
     193,   194,   195,   223,   226,   246,   247,   248,   250,   251,
     252,   257,   261,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   574,   575,   576,   577,   580,   584,
     588,   589,   590,   591,   592,   593,   266,   266,   266,     1,
     117,   145,   286,   287,   288,   289,   266,   266,   266,     1,
      41,    53,    66,    67,    69,    70,    71,    96,   611,   612,
     613,   614,   615,   616,   617,   618,   619,   620,     1,    36,
      75,    84,   108,   112,   120,   124,   125,   215,   259,   260,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   266,   266,   266,     1,   256,   352,   353,
     354,   355,   356,     1,   120,   455,   456,   457,   266,   264,
     267,   267,   267,   265,   322,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   265,   596,
       1,    17,    18,    27,    54,    55,    83,   102,   104,   105,
     106,   110,   114,   120,   133,   134,   147,   170,   177,   220,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,     1,    22,    23,    24,    25,    29,   120,   343,   344,
     345,   346,   347,   348,   349,   350,     1,     3,     6,    13,
      20,    49,    73,    76,    83,    94,   120,   148,   169,   182,
     188,   259,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   495,   496,   497,   498,     1,
      81,   152,   507,   508,   509,   510,     1,    99,   120,   152,
     334,   335,   336,   337,   338,   267,   265,   513,     1,   120,
     152,   517,   518,   519,   520,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   585,
     267,   581,   573,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   265,   523,     1,    13,
      20,    49,    83,   144,   153,   154,   178,   182,   258,   432,
     433,   434,   435,   436,   437,   438,   442,   443,   444,   445,
     446,     1,   152,   258,   501,   502,   503,   504,     1,    73,
      81,    83,   148,   188,   417,   421,   422,   423,   427,   428,
     429,   264,   267,   267,   265,   287,     1,    98,   206,   328,
     329,   330,   331,     1,    20,    49,    83,   120,   144,   161,
     176,   182,   183,   235,   258,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   381,   385,     1,    51,
      98,   152,   449,   450,   451,   452,   453,   267,   267,   267,
     267,   267,   267,   267,   267,   265,   612,   264,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   265,
     308,     1,    13,    19,    77,   120,   184,   185,   292,   293,
     294,   295,   296,   297,   298,   299,     1,   120,   135,   224,
     258,   279,   280,   281,   282,   283,   284,     1,   120,   254,
     470,   471,   472,   473,   264,   267,   265,   353,   206,   267,
     265,   456,     1,   120,   254,   258,   460,   461,   462,   463,
     464,   149,   149,   149,   264,   132,   132,   245,   132,   274,
     132,   274,   274,   274,   132,   132,   245,   245,   245,   264,
     264,   267,   267,   267,   267,   267,   412,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     265,   392,   264,   267,   267,   267,   267,   267,   267,   265,
     344,   264,   267,   267,   267,   267,   267,   267,   267,   492,
     267,   267,   267,   267,   267,   267,   267,   265,   480,   267,
     267,   265,   508,   264,   267,   267,   267,   265,   335,   149,
     264,   267,   267,   265,   518,   245,   245,   274,   274,   149,
     245,   132,   132,   245,   149,   132,   245,   245,   245,   274,
     245,   132,   132,   274,   132,   245,   245,   245,   274,   149,
     132,   132,   274,   132,   132,   132,   132,   245,   245,   267,
     245,   267,   267,   245,   274,   274,   245,   245,   149,   245,
     245,   249,   245,   249,   245,   245,   245,   245,   149,   149,
     132,   274,   245,   132,   274,   274,   245,   245,   264,   264,
     267,   267,   267,   439,   267,   267,   267,   267,   267,   267,
     265,   433,   267,   267,   265,   502,   264,   267,   267,   418,
     267,   267,   265,   422,   149,   149,   264,   264,   267,   267,
     265,   329,   264,   267,   267,   386,   267,   267,   267,   382,
     267,   267,   378,   267,   265,   368,   264,   267,   267,   267,
     265,   450,   245,   245,   245,   149,   245,   245,   245,   274,
     264,   149,   245,   149,   132,   132,   149,   149,   149,   132,
     149,   149,   264,   264,   267,   267,   300,   267,   267,   267,
     265,   293,   264,   267,   267,   267,   267,   265,   280,   264,
     267,   474,   265,   471,   245,   264,   266,   149,   264,   264,
     267,   465,   267,   265,   461,   264,   264,   264,   264,   264,
     264,   162,   163,   164,   165,   166,   167,   168,   273,   274,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     132,   132,   274,   132,   132,   267,   132,   132,   274,   132,
     132,   274,   149,   132,   132,   274,   132,   276,   276,   276,
     264,   149,   149,   149,   149,   245,   149,   264,   149,   211,
     212,   149,   149,   245,   149,   149,   267,   149,   149,   132,
     149,   149,   149,   149,   264,   149,   149,   264,   149,   339,
     340,   149,   149,   264,   264,   149,   149,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   199,   202,   208,   210,   213,   217,   218,   219,
     227,   232,   233,   241,   586,   587,   264,    95,   198,   200,
     203,   207,   216,   221,   231,   233,   236,   582,   583,   199,
     202,   208,   210,   213,   217,   218,   219,   227,   232,   233,
     241,   578,   579,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   149,   149,
     245,   267,   149,   132,   149,   149,   149,   149,   264,   149,
     149,   264,   149,   149,   267,   132,   425,   426,   149,   264,
     264,   264,   149,   149,   264,   149,   245,   267,   149,   149,
     149,   267,   149,   245,   267,   149,   264,   149,   149,   149,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     149,   149,   266,   149,   149,   149,   264,   149,   245,   149,
     149,   264,   149,   267,   264,   264,     1,   120,   230,   254,
     357,   358,   359,   360,   361,   264,   149,   267,   149,   264,
     273,   273,   273,   273,   273,   273,   273,   264,   264,   264,
     264,   264,    68,   151,   413,   414,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,    10,    11,    12,   275,
     276,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,     9,   234,
     493,   494,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   268,   264,   264,   264,   264,   264,   268,   269,
     269,   269,   264,   268,   264,   268,   264,   264,   264,    15,
      43,    50,    61,    90,   121,   122,   123,   131,   159,   179,
     244,   440,   441,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,    34,    66,    74,   224,   234,   419,   420,
     253,   268,   424,   264,   264,   264,   264,   264,     5,    26,
      37,    58,    87,    89,   117,   155,   157,   180,   204,   205,
     209,   213,   216,   219,   222,   228,   237,   240,   242,   243,
     255,   263,   387,   388,   264,   264,   264,    95,   198,   200,
     203,   207,   216,   221,   231,   233,   236,   383,   384,   264,
     264,   199,   202,   208,   210,   213,   217,   218,   219,   227,
     232,   233,   241,   379,   380,   264,   264,   264,   264,   264,
     264,     1,   160,   173,   181,   301,   302,   303,   304,   305,
     264,   264,   264,   264,   264,   264,   264,   264,    89,   158,
     197,   204,   213,   237,   239,   240,   255,   263,   475,   476,
     264,   267,   267,   362,   265,   358,   264,    89,   158,   174,
     197,   204,   213,   237,   239,   240,   255,   262,   263,   466,
     467,   264,   264,   268,   275,   275,   275,   264,   268,   340,
     587,   156,   156,   156,   583,   579,   264,   268,   264,   268,
     132,   426,   264,   269,   269,   269,   264,   268,   269,   269,
     269,   264,   268,   264,   268,   264,   267,   267,   267,   265,
     302,   264,   268,   149,   238,   276,   267,   264,   264,   268,
     414,   494,   441,   420,   156,   156,   156,   388,   156,   156,
     156,   384,   380,   149,   149,   149,   264,   476,   264,   264,
     264,    58,    87,    89,   140,   158,   203,   204,   258,   263,
     363,   364,   467,   264,   264,   264,   264,   268,   364
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   270,   271,   271,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   273,   273,   274,   274,   274,   274,   274,   274,   274,
     274,   275,   275,   276,   276,   276,   276,   278,   277,   279,
     279,   280,   280,   280,   280,   280,   281,   282,   283,   284,
     285,   286,   286,   287,   287,   287,   288,   289,   291,   290,
     292,   292,   293,   293,   293,   293,   293,   293,   293,   294,
     295,   296,   297,   298,   300,   299,   301,   301,   302,   302,
     302,   302,   303,   304,   305,   306,   307,   307,   308,   308,
     308,   308,   308,   308,   308,   308,   308,   308,   308,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   321,   322,   322,   322,   322,   323,   324,
     325,   327,   326,   328,   328,   329,   329,   329,   330,   331,
     333,   332,   334,   334,   335,   335,   335,   335,   336,   337,
     338,   339,   339,   340,   342,   341,   343,   343,   344,   344,
     344,   344,   344,   344,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   352,   353,   353,   353,   354,   356,   355,
     357,   357,   358,   358,   358,   358,   359,   360,   360,   362,
     361,   363,   363,   364,   364,   364,   364,   364,   364,   364,
     364,   364,   366,   365,   367,   367,   368,   368,   368,   368,
     368,   368,   368,   368,   368,   368,   368,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   378,   377,   379,   379,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     380,   380,   380,   382,   381,   383,   383,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   384,   384,   384,   384,
     386,   385,   387,   387,   388,   388,   388,   388,   388,   388,
     388,   388,   388,   388,   388,   388,   388,   388,   388,   388,
     388,   388,   388,   388,   388,   388,   388,   388,   388,   388,
     388,   390,   389,   391,   391,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   392,   392,   392,   392,   392,
     392,   392,   392,   392,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   412,   411,   413,   413,   414,   414,   416,
     415,   418,   417,   419,   419,   420,   420,   420,   420,   420,
     421,   421,   422,   422,   422,   422,   422,   422,   424,   423,
     425,   425,   426,   426,   427,   428,   429,   431,   430,   432,
     432,   433,   433,   433,   433,   433,   433,   433,   433,   433,
     433,   433,   434,   435,   436,   437,   439,   438,   440,   440,
     441,   441,   441,   441,   441,   441,   441,   441,   441,   441,
     441,   441,   442,   443,   444,   445,   446,   448,   447,   449,
     449,   450,   450,   450,   450,   451,   452,   453,   454,   455,
     455,   456,   456,   457,   459,   458,   460,   460,   461,   461,
     461,   461,   462,   463,   465,   464,   466,   466,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     469,   468,   470,   470,   471,   471,   471,   472,   474,   473,
     475,   475,   476,   476,   476,   476,   476,   476,   476,   476,
     476,   476,   478,   477,   479,   479,   480,   480,   480,   480,
     480,   480,   480,   480,   480,   480,   480,   480,   480,   480,
     480,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   490,   492,   491,   493,   493,   494,   494,   495,
     496,   497,   498,   500,   499,   501,   501,   502,   502,   502,
     503,   504,   506,   505,   507,   507,   508,   508,   508,   509,
     510,   511,   512,   512,   513,   513,   514,   516,   515,   517,
     517,   518,   518,   518,   519,   520,   521,   522,   522,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   524,   525,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   553,   554,   554,   555,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   573,   572,   574,   575,   576,   577,   578,   578,   579,
     579,   579,   579,   579,   579,   579,   579,   579,   579,   579,
     579,   581,   580,   582,   582,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   585,   584,
     586,   586,   587,   587,   587,   587,   587,   587,   587,   587,
     587,   587,   587,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   595,   596,   596,   596,   596,   596,   596,   596,
     596,   596,   596,   596,   596,   596,   596,   597,   598,   599,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   611,   612,   612,   612,   612,   612,   612,   612,
     612,   612,   613,   614,   615,   616,   617,   618,   619,   620
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     2,     3,     3,     3,     0,     6,     2,
       1,     1,     1,     1,     1,     2,     4,     4,     4,     4,
       5,     2,     1,     1,     1,     2,     4,     4,     0,     6,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     4,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     2,     4,     4,     4,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     5,     2,     1,     1,     1,     1,     2,     4,     4,
       4,     0,     6,     2,     1,     1,     1,     2,     4,     4,
       0,     6,     2,     1,     1,     1,     1,     2,     4,     4,
       4,     3,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     4,
       4,     5,     2,     1,     1,     1,     2,     4,     0,     6,
       2,     1,     1,     1,     1,     2,     4,     4,     4,     0,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     0,     5,     3,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     5,     3,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       0,     5,     3,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     6,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     0,
       6,     0,     5,     3,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     0,     5,
       3,     1,     1,     3,     4,     4,     4,     0,     6,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     4,     4,     4,     4,     0,     6,     2,
       1,     1,     1,     1,     2,     4,     4,     4,     5,     2,
       1,     1,     1,     4,     0,     6,     2,     1,     1,     1,
       1,     2,     4,     4,     0,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     6,     2,     1,     1,     1,     2,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     4,
       4,     4,     4,     0,     6,     2,     1,     1,     1,     1,
       4,     4,     0,     6,     2,     1,     1,     1,     1,     4,
       4,     5,     2,     1,     1,     1,     4,     0,     6,     2,
       1,     1,     1,     1,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     0,     5,     4,     4,     4,     4,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     5,     3,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       5,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       5,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     4,     4,     4,     4,     4,     4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 31:
#line 460 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3139 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 462 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number);
		}
#line 3147 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 466 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);
		}
#line 3155 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 470 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 + (yyvsp[0].number);
		}
#line 3163 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 474 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 + (yyvsp[0].number);
		}
#line 3171 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 478 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 + (yyvsp[0].number);
		}
#line 3179 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 482 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 + (yyvsp[0].number);
		}
#line 3187 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 486 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 * 4 + (yyvsp[0].number);
                }
#line 3195 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 490 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 365 + (yyvsp[0].number);
                }
#line 3203 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 495 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3209 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 496 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number); }
#line 3215 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 497 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 3221 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 498 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 + (yyvsp[0].number); }
#line 3227 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 499 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 * 1024 + (yyvsp[0].number); }
#line 3233 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 506 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.ptr.alias = MyMalloc(sizeof(struct alias_entry));
}
#line 3244 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 512 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  dlinkAdd(block_state.ptr.alias, &block_state.ptr.alias->node, &alias_items);
  alias_add(block_state.ptr.alias);
}
#line 3256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 524 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  struct alias_name *nm = MyMalloc(sizeof(struct alias_name));

  strlcpy(nm->name, yylval.string, sizeof(nm->name));
  nm->parent = block_state.ptr.alias;

  dlinkAdd(nm, &nm->node, &block_state.ptr.alias->names);
}
#line 3272 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 537 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->user, yylval.string, sizeof(block_state.ptr.alias->user));
}
#line 3281 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 543 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->server, yylval.string, sizeof(block_state.ptr.alias->server));
}
#line 3290 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 549 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.ptr.alias->flags |= CONF_FLAGS_OPER_ONLY;
  }
}
#line 3302 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 567 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_module(libio_basename(yylval.string));
}
#line 3311 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 573 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    mod_add_path(yylval.string);
}
#line 3320 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.ssl = sslprofile_create();
}
#line 3331 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 587 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  dlink_node *ptr;

  if (conf_parser_ctx.pass != 1)
    break;

  DLINK_FOREACH(ptr, profile->identities.head)
  {
    struct sslprofile_identity *id = ptr->data;

    if (profile->dh)
      SSL_CTX_set_tmp_dh(id->server_ctx, profile->dh);

#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
    if (profile->curve)
      SSL_CTX_set_tmp_ecdh(id->server_ctx, profile->curve);
#endif

    if (!EmptyString(profile->cipher_list))
    {
      SSL_CTX_set_cipher_list(id->server_ctx, profile->cipher_list);

      SSL_CTX_set_cipher_list(id->client_ctx, profile->cipher_list);
    }

    if (!EmptyString(profile->ca_file))
    {
      if (!SSL_CTX_load_verify_locations(id->server_ctx, profile->ca_file, NULL))
      {
        const char *s = ERR_lib_error_string(ERR_get_error());

        ilog(LOG_TYPE_IRCD, "Could not load verify location %s -- %s", profile->ca_file, s);
      }
    }
  }

  dlinkAddTail(block_state.ptr.ssl, &block_state.ptr.ssl->node, &sslprofile_items);
  block_state.ptr.ssl = NULL;
}
#line 3376 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 635 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->name, yylval.string, sizeof(entry->name));
}
#line 3387 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 643 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
  {
    BIO *file = BIO_new_file(yylval.string, "r");

    if (file)
    {
      DH *dh = PEM_read_bio_DHparams(file, NULL, NULL, NULL);

      BIO_free(file);

      if (dh)
      {
        if (DH_size(dh) < 256)
        {
          conf_error_report("Ignoring sslprofile::dh_param_file -- need at least a 2048 bit DH prime size");
          DH_free(dh);
        }
        else
        {
          entry->dh = dh;
        }
      }
    }
    else
      conf_error_report("Ignoring sslprofile::dh_param_file -- could not open/read Diffie-Hellman parameter file");
  }
}
#line 3422 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 675 "conf_parser.y" /* yacc.c:1646  */
    {
#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
  struct sslprofile *entry = block_state.ptr.ssl;
  int nid = 0;
  EC_KEY *key = NULL;

  if (conf_parser_ctx.pass == 1)
  {
    if ((nid = OBJ_sn2nid(yylval.string)) == 0)
    {
        conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- unknown curve name");
        break;
    }

    if ((key = EC_KEY_new_by_curve_name(nid)) == NULL)
    {
      conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- could not create curve");
      break;
    }

    entry->curve = key;
  }
#endif
}
#line 3451 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 701 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->cipher_list, yylval.string, sizeof(entry->cipher_list));
}
#line 3462 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 709 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->ca_file, yylval.string, sizeof(entry->ca_file));
}
#line 3473 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 717 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.identity = sslprofile_identity_create(block_state.ptr.ssl);
}
#line 3484 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 724 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  struct sslprofile_identity *id = block_state.ptr.identity;

  if (conf_parser_ctx.pass != 1)
    break;

  if (id == NULL)
    break;

  dlinkAddTail(id, &id->node, &profile->identities);
  block_state.ptr.identity = NULL;
}
#line 3502 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 744 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  char *str;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  str = xstrdup(yylval.string);
  dlinkAdd(str, make_dlink_node(), &entry->server_names);
}
#line 3520 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 759 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  BIO *file = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  if (entry->rsa_private_key)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;
  }

  if (entry->rsa_private_key_file)
  {
    MyFree(entry->rsa_private_key_file);
    entry->rsa_private_key_file = NULL;
  }

  entry->rsa_private_key_file = xstrdup(yylval.string);

  if ((file = BIO_new_file(yylval.string, "r")) == NULL)
  {
    conf_error_report("File open failed, ignoring");
    break;
  }

  entry->rsa_private_key = PEM_read_bio_RSAPrivateKey(file, NULL, 0, NULL);

  BIO_set_close(file, BIO_CLOSE);
  BIO_free(file);

  if (entry->rsa_private_key == NULL)
  {
    conf_error_report("Couldn't extract key, ignoring");
    break;
  }

  if (!RSA_check_key(entry->rsa_private_key))
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Invalid key, ignoring");
    break;
  }

  if (RSA_size(entry->rsa_private_key) < 256)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Ignoring sslprofile::identity::rsa_private_key_file -- need at least a 2048 bit key size");
  }
}
#line 3583 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 819 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;

  if (conf_parser_ctx.pass == 1 && entry)
  {
    if (!entry->rsa_private_key_file)
    {
      conf_error_report("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(entry->server_ctx, yylval.string) <= 0 ||
        SSL_CTX_use_certificate_chain_file(entry->client_ctx, yylval.string) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not open/read certificate file");
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(entry->server_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(entry->client_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }

    if (!SSL_CTX_check_private_key(entry->server_ctx) ||
        !SSL_CTX_check_private_key(entry->client_ctx))
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }
  }
}
#line 3626 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 873 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.name)
  {
    if (valid_servname(yylval.string))
      ServerInfo.name = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::name -- invalid name. Aborting.");
      exit(0);
    }
  }
}
#line 3644 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 888 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      ServerInfo.sid = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::sid -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
#line 3662 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 903 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ServerInfo.description);
    ServerInfo.description = xstrdup(yylval.string);
  }
}
#line 3674 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 912 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      *p = '\0';

    MyFree(ServerInfo.network_name);
    ServerInfo.network_name = xstrdup(yylval.string);
  }
}
#line 3691 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 926 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(ServerInfo.network_desc);
  ServerInfo.network_desc = xstrdup(yylval.string);
}
#line 3703 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 935 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
#line 3734 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 963 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
#line 3767 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 993 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < MAXCLIENTS_MIN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MIN;
  }
  else if ((yyvsp[-1].number) > MAXCLIENTS_MAX)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MAX;
  }
  else
    ServerInfo.max_clients = (yyvsp[-1].number);
}
#line 3795 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1018 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 9)
  {
    conf_error_report("max_nick_length too low, setting to 9");
    ServerInfo.max_nick_length = 9;
  }
  else if ((yyvsp[-1].number) > NICKLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_nick_length too high, setting to %d", NICKLEN);
    conf_error_report(buf);
    ServerInfo.max_nick_length = NICKLEN;
  }
  else
    ServerInfo.max_nick_length = (yyvsp[-1].number);
}
#line 3820 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1040 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 80)
  {
    conf_error_report("max_topic_length too low, setting to 80");
    ServerInfo.max_topic_length = 80;
  }
  else if ((yyvsp[-1].number) > TOPICLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_topic_length too high, setting to %d", TOPICLEN);
    conf_error_report(buf);
    ServerInfo.max_topic_length = TOPICLEN;
  }
  else
    ServerInfo.max_topic_length = (yyvsp[-1].number);
}
#line 3845 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1062 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ServerInfo.hub = yylval.number;
}
#line 3854 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1077 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.name);
  AdminInfo.name = xstrdup(yylval.string);
}
#line 3866 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1086 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.email);
  AdminInfo.email = xstrdup(yylval.string);
}
#line 3878 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1095 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.description);
  AdminInfo.description = xstrdup(yylval.string);
}
#line 3890 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1107 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 3899 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1111 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.file.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
    motd_add(ptr->data, block_state.file.buf);
}
#line 3916 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1128 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 3925 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1134 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 3934 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1144 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    reset_block_state();
    block_state.ptr.dnsbl = MyMalloc(sizeof(struct dnsbl_entry));
  }
}
#line 3946 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1152 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_entry *dnsbl = block_state.ptr.dnsbl;

    if (dlink_list_length(&dnsbl->matches) == 0)
    {
      /* Add a default match */
      struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));
      parse_netmask("127.0.0.0/8", &match->ip, &match->bits);
      dlinkAdd(match, &match->node, &dnsbl->matches);
    }

    dlinkAdd(dnsbl, &dnsbl->node, &dnsbl_items);
  }
}
#line 3967 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1174 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->name, yylval.string, sizeof(block_state.ptr.dnsbl->name));
}
#line 3976 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1180 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->reason, yylval.string, sizeof(block_state.ptr.dnsbl->reason));
}
#line 3985 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1188 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));

    if (parse_netmask((yyvsp[0].string), &match->ip, &match->bits) == HM_IPV4)
    {
      dlinkAdd(match, &match->node, &block_state.ptr.dnsbl->matches);
    }
    else
    {
      char buf[IRCD_BUFSIZE];

      snprintf(buf, sizeof(buf), "dnsbl match %s not an IPv4 mask, ignored", (yyvsp[0].string));
      conf_error_report(buf);

      MyFree(match);
    }
  }
}
#line 4010 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1214 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();
  block_state.ptr.cloak = MyMalloc(sizeof(struct cloak_config));
}
#line 4022 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1222 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  struct cloak_config *cloak = block_state.ptr.cloak;
  dlinkAdd(cloak, &cloak->node, &cloak_items);
}
#line 4034 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1240 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.cloak->name, yylval.string, sizeof(block_state.ptr.cloak->name));
}
#line 4043 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1246 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ptr.cloak->default_cloak = yylval.number;
}
#line 4052 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1252 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key);
    cloak->cloak_key = xstrdup(yylval.string);
  }
}
#line 4066 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1263 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key1);
    cloak->cloak_key1 = xstrdup(yylval.string);
  }
}
#line 4080 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1274 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key2);
    cloak->cloak_key2 = xstrdup(yylval.string);
  }
}
#line 4094 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1285 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key3);
    cloak->cloak_key3 = xstrdup(yylval.string);
  }
}
#line 4108 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1305 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
#line 4117 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1311 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 4126 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1315 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (block_state.type.value && block_state.file.buf[0])
    log_set_file(block_state.type.value, block_state.size.value,
                 block_state.file.buf);
}
#line 4139 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1331 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4150 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1339 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = (yyvsp[-1].number);
}
#line 4158 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1342 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = 0;
}
#line 4166 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1347 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = 0;
}
#line 4175 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1354 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_USER;
}
#line 4184 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1358 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_OPER;
}
#line 4193 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1362 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_GLINE;
}
#line 4202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1366 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_XLINE;
}
#line 4211 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1370 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_RESV;
}
#line 4220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1374 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DLINE;
}
#line 4229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1378 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KLINE;
}
#line 4238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1382 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KILL;
}
#line 4247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1386 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DEBUG;
}
#line 4256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1396 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
}
#line 4268 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1403 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;
  if (!block_state.file.buf[0] &&
      !block_state.rpass.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    conf         = conf_make(CONF_OPER);
    conf->name   = xstrdup(block_state.name.buf);
    conf->user   = xstrdup(block_state.user.buf);
    conf->host   = xstrdup(block_state.host.buf);

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);

    conf->flags = block_state.flags.value;
    conf->modes = block_state.modes.value;
    conf->snomask.local = block_state.snomask_local.value;
    conf->snomask.remote = block_state.snomask_remote.value;
    conf->port  = block_state.port.value;
    conf->htype = parse_netmask(conf->host, &conf->addr, &conf->bits);

    conf_add_class_to_conf(conf, block_state.class.buf);

    if (block_state.file.buf[0])
    {
      BIO *file = NULL;
      RSA *pkey = NULL;

      if ((file = BIO_new_file(block_state.file.buf, "r")) == NULL)
      {
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- file doesn't exist");
        break;
      }

      if ((pkey = PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL)) == NULL)
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- Key invalid; check key syntax");
      else
      {
        if (RSA_size(pkey) > 128)
          ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- key size must be 1024 or below");
        else
          conf->rsa_public_key = pkey;
      }

      BIO_set_close(file, BIO_CLOSE);
      BIO_free(file);
    }
  }
}
#line 4345 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1484 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 4354 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1490 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 4363 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1496 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 4372 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1502 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
  else
    block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
}
#line 4386 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1513 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1519 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 4404 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1525 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_SSL;
  else
    block_state.flags.value &= ~CONF_FLAGS_SSL;
}
#line 4418 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1536 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4427 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1542 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value = 0;
}
#line 4436 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1550 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_NOCTCP;
}
#line 4445 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1555 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_DEAF;
}
#line 4454 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1560 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_HIDECHANNELS;
}
#line 4463 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1565 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_OPERWALL;
}
#line 4472 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1570 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SERVNOTICE;
}
#line 4481 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1575 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_INVISIBLE;
}
#line 4490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_WALLOP;
}
#line 4499 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1585 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SOFTCALLERID;
}
#line 4508 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1590 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_CALLERID;
}
#line 4517 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1595 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_LOCOPS;
}
#line 4526 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1600 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_REGONLY;
}
#line 4535 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1605 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SPY;
}
#line 4544 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1611 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value = block_state.snomask_remote.value = 0;
}
#line 4553 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1619 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_bots.flag;
}
#line 4562 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1624 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_bots.flag;
}
#line 4571 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1629 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_cconn.flag;
}
#line 4580 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1634 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_cconn.flag;
}
#line 4589 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1639 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_debug.flag;
}
#line 4598 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1644 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_full.flag;
}
#line 4607 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1649 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_skill.flag;
}
#line 4616 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1654 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_nchange.flag;
}
#line 4625 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1659 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_rej.flag;
}
#line 4634 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1664 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_unauth.flag;
}
#line 4643 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1669 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_spy.flag;
}
#line 4652 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1674 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_link.flag;
}
#line 4661 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1679 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
     block_state.snomask_local.value |= sno_link.flag;
}
#line 4670 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1685 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = 0;
}
#line 4679 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1692 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL_REMOTE;
}
#line 4688 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1696 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_FARCONNECT;
}
#line 4697 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1700 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_N;
}
#line 4706 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1704 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL;
}
#line 4715 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1708 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT_REMOTE;
}
#line 4724 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1712 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT;
}
#line 4733 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1716 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT_REMOTE;
}
#line 4742 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1720 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT;
}
#line 4751 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1724 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_K;
}
#line 4760 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1728 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNKLINE;
}
#line 4769 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1732 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DLINE;
}
#line 4778 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1736 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNDLINE;
}
#line 4787 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1740 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_XLINE;
}
#line 4796 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1744 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNXLINE;
}
#line 4805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1748 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLINE;
}
#line 4814 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1752 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DIE;
}
#line 4823 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1756 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_RESTART;
}
#line 4832 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1760 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REHASH;
}
#line 4841 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1764 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_ADMIN;
}
#line 4850 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1768 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_OPERWALL;
}
#line 4859 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1772 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLOBOPS;
}
#line 4868 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1776 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLOPS;
}
#line 4877 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1780 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLUSERS;
}
#line 4886 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1784 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_LOCOPS;
}
#line 4895 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1788 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REMOTEBAN;
}
#line 4904 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1792 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SET;
}
#line 4913 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1796 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_MODULE;
}
#line 4922 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1806 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();

  block_state.ping_freq.value = DEFAULT_PINGFREQUENCY;
  block_state.con_freq.value  = DEFAULT_CONNECTFREQUENCY;
  block_state.max_total.value = MAXIMUM_LINKS_DEFAULT;
  block_state.max_sendq.value = DEFAULT_SENDQ;
  block_state.max_recvq.value = DEFAULT_RECVQ;
}
#line 4939 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1818 "conf_parser.y" /* yacc.c:1646  */
    {
  struct ClassItem *class = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (!block_state.class.buf[0])
    break;

  if (!(class = class_find(block_state.class.buf, 0)))
    class = class_make();

  class->active = 1;
  MyFree(class->name);
  class->name = xstrdup(block_state.class.buf);
  class->ping_freq = block_state.ping_freq.value;
  class->max_perip = block_state.max_perip.value;
  class->con_freq = block_state.con_freq.value;
  class->max_total = block_state.max_total.value;
  class->max_global = block_state.max_global.value;
  class->max_local = block_state.max_local.value;
  class->soft_sendq = block_state.soft_sendq.value;
  class->flood_burst = block_state.flood_burst.value;
  class->flood_limit = block_state.flood_limit.value;
  class->max_sendq = block_state.max_sendq.value;
  class->max_recvq = block_state.max_recvq.value;

  if (block_state.min_idle.value > block_state.max_idle.value)
  {
    block_state.min_idle.value = 0;
    block_state.max_idle.value = 0;
    block_state.flags.value &= ~CLASS_FLAGS_FAKE_IDLE;
  }

  class->flags = block_state.flags.value;
  class->min_idle = block_state.min_idle.value;
  class->max_idle = block_state.max_idle.value;

  rebuild_cidr_list(class);

  class->cidr_bitlen_ipv4 = block_state.cidr_bitlen_ipv4.value;
  class->cidr_bitlen_ipv6 = block_state.cidr_bitlen_ipv6.value;
  class->number_per_cidr = block_state.number_per_cidr.value;
  class->max_channels = block_state.max_channels.value;
}
#line 4989 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1882 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4998 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1888 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ping_freq.value = (yyvsp[-1].number);
}
#line 5007 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1894 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_perip.value = (yyvsp[-1].number);
}
#line 5016 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1900 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.con_freq.value = (yyvsp[-1].number);
}
#line 5025 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1906 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_total.value = (yyvsp[-1].number);
}
#line 5034 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1912 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_global.value = (yyvsp[-1].number);
}
#line 5043 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1918 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_local.value = (yyvsp[-1].number);
}
#line 5052 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1924 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.soft_sendq.value = (yyvsp[-1].number);
}
#line 5061 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1930 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_burst.value = (yyvsp[-1].number);
}
#line 5070 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1936 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_limit.value = (yyvsp[-1].number);
}
#line 5079 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1942 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_sendq.value = (yyvsp[-1].number);
}
#line 5088 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1948 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    if ((yyvsp[-1].number) >= CLIENT_FLOOD_MIN && (yyvsp[-1].number) <= CLIENT_FLOOD_MAX)
      block_state.max_recvq.value = (yyvsp[-1].number);
}
#line 5098 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1955 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv4.value = (yyvsp[-1].number) > 32 ? 32 : (yyvsp[-1].number);
}
#line 5107 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1961 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv6.value = (yyvsp[-1].number) > 128 ? 128 : (yyvsp[-1].number);
}
#line 5116 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1967 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.number_per_cidr.value = (yyvsp[-1].number);
}
#line 5125 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1973 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.min_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5137 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1982 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.max_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5149 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1991 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_channels.value = (yyvsp[-1].number);
}
#line 5158 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1997 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value &= CLASS_FLAGS_FAKE_IDLE;
}
#line 5167 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2004 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_RANDOM_IDLE;
}
#line 5176 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2008 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_HIDE_IDLE_FROM_OPERS;
}
#line 5185 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2018 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5194 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2024 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5203 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2031 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_SSL;
}
#line 5212 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2035 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HIDDEN;
}
#line 5221 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2039 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
   block_state.flags.value |= LISTENER_SERVER;
}
#line 5230 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2043 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HTTP;
}
#line 5239 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2047 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_DEFER;
}
#line 5248 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2056 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5257 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2064 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    add_listener((yyvsp[0].number), block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5281 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2083 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    int i;
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    for (i = (yyvsp[-2].number); i <= (yyvsp[0].number); ++i)
      add_listener(i, block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5307 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2106 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5316 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2112 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5325 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2118 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 5334 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2127 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5343 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2131 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    if (EmptyString(block_state.host.buf))
      continue;

    conf        = conf_make(CONF_CLIENT);
    conf->user  = xstrdup(block_state.user.buf);
    conf->host  = xstrdup(block_state.host.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);
    if (block_state.name.buf[0])
      conf->name = xstrdup(block_state.name.buf);

    conf->flags = block_state.flags.value;
    conf->port  = block_state.port.value;

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.ca.buf[0])
    {
      int ret;

      conf->x509_store = X509_STORE_new();
      ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
      if (ret != 1)
      {
        X509_STORE_free(conf->x509_store);
        conf->x509_store = NULL;

        ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring auth block", block_state.ca.buf);
        conf_free(conf);
        continue;
      }
    }

    conf_add_class_to_conf(conf, block_state.class.buf);
    add_conf_by_address(CONF_CLIENT, conf);
  }
}
#line 5407 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2198 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5416 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2204 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5425 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2210 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5434 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2216 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 5448 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2227 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value &= (CONF_FLAGS_ENCRYPTED | CONF_FLAGS_SPOOF_IP);
}
#line 5457 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2234 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SPOOF_NOTICE;
}
#line 5466 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2238 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NOLIMIT;
}
#line 5475 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2242 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTKLINE;
}
#line 5484 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2246 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTDNSBL;
}
#line 5493 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2250 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_IDENTD;
}
#line 5502 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2254 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_CAN_FLOOD;
}
#line 5511 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2258 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NO_TILDE;
}
#line 5520 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2262 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTGLINE;
}
#line 5529 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2266 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTRESV;
}
#line 5538 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2270 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_WEBIRC;
}
#line 5547 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2274 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_ACCOUNT;
}
#line 5556 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2278 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_PASSWORD;
}
#line 5565 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2284 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (strlen(yylval.string) <= HOSTLEN && valid_hostname(yylval.string))
  {
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
    block_state.flags.value |= CONF_FLAGS_SPOOF_IP;
  }
  else
    ilog(LOG_TYPE_IRCD, "Spoof either is too long or contains invalid characters. Ignoring it.");
}
#line 5582 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2298 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
  block_state.flags.value |= CONF_FLAGS_REDIR;
}
#line 5594 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2307 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.flags.value |= CONF_FLAGS_REDIR;
  block_state.port.value = (yyvsp[-1].number);
}
#line 5606 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2316 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 5617 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2324 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 5628 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2336 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  strlcpy(block_state.rpass.buf, CONF_NOREASON, sizeof(block_state.rpass.buf));
}
#line 5640 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2343 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  create_resv(block_state.name.buf, block_state.rpass.buf, &block_state.mask.list);
}
#line 5651 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2354 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5660 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2360 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5669 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2366 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5678 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2381 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (valid_servname(yylval.string))
  {
    struct MaskItem *conf = conf_make(CONF_SERVICE);
    conf->name = xstrdup(yylval.string);
  }
}
#line 5693 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2396 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  strlcpy(block_state.user.buf, "*", sizeof(block_state.user.buf));
  strlcpy(block_state.host.buf, "*", sizeof(block_state.host.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5709 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2407 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_ULINE);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);
}
#line 5726 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2424 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5735 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2430 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 5757 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2449 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5766 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2456 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5775 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2460 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5784 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2464 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5793 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2468 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5802 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2472 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5811 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2476 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5820 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2480 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5829 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2484 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5838 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2488 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5847 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2492 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_SESSION;
}
#line 5856 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2496 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_WLINE;
}
#line 5865 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2500 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5874 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2509 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5888 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2518 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_CLUSTER);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
}
#line 5903 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2533 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5912 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2539 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5921 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2546 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5930 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2550 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5939 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2554 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5948 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2558 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5957 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2562 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5966 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2566 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5975 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2570 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5984 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2574 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5993 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2578 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 6002 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2582 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 6011 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2591 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.aftype.value = AF_INET;
  block_state.port.value = PORTNUM;
}
#line 6025 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2600 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;
  struct addrinfo hints, *res;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0] ||
      !block_state.host.buf[0])
    break;

  if (!block_state.rpass.buf[0] ||
      !block_state.spass.buf[0])
    break;

  if (has_wildcards(block_state.name.buf))
    break;

  conf = conf_make(CONF_SERVER);
  conf->port = block_state.port.value;
  conf->flags = block_state.flags.value;
  conf->aftype = block_state.aftype.value;
  conf->host = xstrdup(block_state.host.buf);
  conf->name = xstrdup(block_state.name.buf);
  conf->passwd = xstrdup(block_state.rpass.buf);
  conf->spasswd = xstrdup(block_state.spass.buf);

  if (block_state.cert.buf[0])
    conf->certfp = xstrdup(block_state.cert.buf);

  dlinkMoveList(&block_state.leaf.list, &conf->leaf_list);
  dlinkMoveList(&block_state.hub.list, &conf->hub_list);

  if (block_state.bind.buf[0])
  {
    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(block_state.bind.buf, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", block_state.bind.buf);
    else
    {
      assert(res != NULL);

      memcpy(&conf->bind, res->ai_addr, res->ai_addrlen);
      conf->bind.ss.ss_family = res->ai_family;
      conf->bind.ss_len = res->ai_addrlen;
      freeaddrinfo(res);
    }
  }

  if (block_state.ca.buf[0])
  {
    int ret;

    conf->x509_store = X509_STORE_new();
    ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
    if (ret != 1)
    {
      X509_STORE_free(conf->x509_store);
      conf->x509_store = NULL;

      ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring connect block", block_state.ca.buf);
      conf_free(conf);
      break;
    }
  }

  conf->ssl_profile = xstrdup(block_state.profile.buf);

  conf_add_class_to_conf(conf, block_state.class.buf);
  lookup_confhost(conf);
}
#line 6106 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2687 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6115 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2693 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.host.buf, yylval.string, sizeof(block_state.host.buf));
}
#line 6124 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2699 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.bind.buf, yylval.string, sizeof(block_state.bind.buf));
}
#line 6133 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2705 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.spass.buf, yylval.string, sizeof(block_state.spass.buf));
}
#line 6149 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2718 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6165 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2731 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 6174 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2737 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 6183 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2743 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 6192 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2749 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = (yyvsp[-1].number);
}
#line 6201 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2755 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET;
}
#line 6210 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2759 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET6;
#endif
}
#line 6221 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2767 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value &= CONF_FLAGS_ENCRYPTED;
}
#line 6229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2773 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_ALLOW_AUTO_CONN;
}
#line 6238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2777 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SSL;
}
#line 6247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2783 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 6261 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2794 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.hub.list);
}
#line 6270 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2800 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.leaf.list);
}
#line 6279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2806 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 6288 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2816 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6297 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2820 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.user.buf[0] ||
      !block_state.host.buf[0])
    break;

  conf = conf_make(CONF_KLINE);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
  add_conf_by_address(CONF_KLINE, conf);
}
#line 6322 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2845 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 6345 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2865 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6354 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2874 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6363 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2878 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.addr.buf[0])
    break;

  if (parse_netmask(block_state.addr.buf, NULL, NULL) != HM_HOST)
  {
    conf = conf_make(CONF_DLINE);
    conf->host = xstrdup(block_state.addr.buf);

    if (block_state.rpass.buf[0])
      conf->reason = xstrdup(block_state.rpass.buf);
    else
      conf->reason = xstrdup(CONF_NOREASON);
    add_conf_by_address(CONF_DLINE, conf);
  }
}
#line 6389 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2904 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 6398 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2910 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6407 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2924 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      struct MaskItem *conf = conf_make(CONF_EXEMPT);
      conf->host = xstrdup(yylval.string);

      add_conf_by_address(CONF_EXEMPT, conf);
    }
  }
}
#line 6424 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2941 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6433 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2945 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;

  conf = conf_make(CONF_XLINE);
  conf->name = xstrdup(block_state.name.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
}
#line 6455 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2967 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6464 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2973 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6473 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 611:
#line 3022 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_watch = (yyvsp[-1].number);
}
#line 6481 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 612:
#line 3027 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cycle_on_host_change = yylval.number;
}
#line 6490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 613:
#line 3033 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key);
    ConfigFileEntry.cloak_key = xstrdup(yylval.string);
  }
}
#line 6502 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3042 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.account_whois = yylval.number;
}
#line 6511 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3048 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.glines = yylval.number;
}
#line 6520 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3054 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_time = (yyvsp[-1].number);
}
#line 6529 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3060 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_request_time = (yyvsp[-1].number);
}
#line 6538 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3066 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[-1].number);
}
#line 6546 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3071 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[-1].number);
}
#line 6554 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3076 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    ConfigFileEntry.kline_reason = xstrdup(yylval.string);
  }
}
#line 6566 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3085 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
#line 6574 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3090 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[-1].number);
}
#line 6582 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 3095 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
#line 6590 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 3100 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
#line 6598 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3105 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
#line 6606 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3110 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
#line 6614 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3115 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_time = (yyvsp[-1].number);
}
#line 6622 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3120 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[-1].number);
}
#line 6630 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3125 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_accept = (yyvsp[-1].number);
}
#line 6638 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3130 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[-1].number);
}
#line 6646 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3135 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[-1].number);
}
#line 6654 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3140 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[-1].number);
}
#line 6663 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3146 "conf_parser.y" /* yacc.c:1646  */
    {
  if (((yyvsp[-1].number) > 0) && conf_parser_ctx.pass == 1)
  {
    ilog(LOG_TYPE_IRCD, "You haven't read your config file properly.");
    ilog(LOG_TYPE_IRCD, "There is a line in the example conf that will kill your server if not removed.");
    ilog(LOG_TYPE_IRCD, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
#line 6677 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3157 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
#line 6685 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3162 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
#line 6693 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3167 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
#line 6701 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3172 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
#line 6709 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3177 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
#line 6717 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3182 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_u_oper_only = yylval.number;
}
#line 6725 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3187 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
#line 6733 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3190 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
#line 6741 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3195 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
#line 6749 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3198 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
#line 6757 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3203 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_m_oper_only = yylval.number;
}
#line 6765 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3208 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait = (yyvsp[-1].number);
}
#line 6773 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3213 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[-1].number);
}
#line 6781 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3218 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
#line 6789 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3223 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[-1].number);
}
#line 6797 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3228 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.short_motd = yylval.number;
}
#line 6805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3233 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
#line 6813 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3238 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
#line 6821 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3243 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[-1].number);
}
#line 6829 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 653:
#line 3248 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_targets = (yyvsp[-1].number);
}
#line 6837 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3253 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && valid_servname(yylval.string))
  {
    MyFree(ConfigFileEntry.service_name);
    ConfigFileEntry.service_name = xstrdup(yylval.string);
  }
}
#line 6849 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3262 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.sasl_name);
    ConfigFileEntry.sasl_name = xstrdup(yylval.string);
  }
}
#line 6861 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3271 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
#line 6869 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3276 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.nick_collide_realhost = yylval.number;
}
#line 6877 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3281 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
#line 6885 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3286 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_num = yylval.number;
}
#line 6893 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3291 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_time = (yyvsp[-1].number);
}
#line 6901 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3296 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes = 0;
}
#line 6909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3301 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_extbans = yylval.number;
}
#line 6917 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3306 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_forwarding = yylval.number;
}
#line 6925 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 665:
#line 3311 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if ((ConfigFileEntry.message_digest_algorithm = EVP_get_digestbyname(yylval.string)) == NULL)
    {
      ConfigFileEntry.message_digest_algorithm = EVP_sha1();
      conf_error_report("Ignoring general::ssl_message_digest_algorithm -- unknown message digest algorithm");
    }
  }
}
#line 6940 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3323 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.mass_highlight_nicks = (yyvsp[-1].number);
}
#line 6948 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 669:
#line 3329 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_NOCTCP;
}
#line 6956 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 670:
#line 3333 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
#line 6964 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3337 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_HIDECHANNELS;
}
#line 6972 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3341 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
#line 6980 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 673:
#line 3345 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
#line 6988 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 674:
#line 3349 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
#line 6996 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3353 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
#line 7004 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3357 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
#line 7012 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3361 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
#line 7020 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3365 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
#line 7028 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3369 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_REGONLY;
}
#line 7036 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3373 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
#line 7044 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3378 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local = ConfigFileEntry.oper_snomasks.remote = 0;
}
#line 7052 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 685:
#line 3385 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_bots.flag;
}
#line 7060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 686:
#line 3389 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_bots.flag;
}
#line 7068 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3393 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_cconn.flag;
}
#line 7076 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 688:
#line 3397 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_cconn.flag;
}
#line 7084 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 689:
#line 3401 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_debug.flag;
}
#line 7092 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 690:
#line 3405 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_nchange.flag;
}
#line 7100 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3409 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_full.flag;
}
#line 7108 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3413 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_skill.flag;
}
#line 7116 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3417 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_rej.flag;
}
#line 7124 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3421 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_unauth.flag;
}
#line 7132 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3425 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_spy.flag;
}
#line 7140 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3429 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_link.flag;
}
#line 7148 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3433 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_link.flag;
}
#line 7156 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3438 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
#line 7164 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3444 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NOCTCP;
}
#line 7172 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3448 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
#line 7180 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 704:
#line 3452 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_HIDECHANNELS;
}
#line 7188 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 705:
#line 3456 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
#line 7196 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 706:
#line 3460 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
#line 7204 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 707:
#line 3464 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
#line 7212 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 708:
#line 3468 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
#line 7220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 709:
#line 3472 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
#line 7228 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 710:
#line 3476 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
#line 7236 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 711:
#line 3480 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
#line 7244 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 712:
#line 3484 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REGONLY;
}
#line 7252 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 713:
#line 3488 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
#line 7260 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 714:
#line 3493 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.disable_chmodes);
    ConfigFileEntry.disable_chmodes = xstrdup(yylval.string);
  }
}
#line 7272 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 715:
#line 3502 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.use_target_change = yylval.number;
}
#line 7280 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 716:
#line 3507 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[-1].number);
}
#line 7288 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 717:
#line 3512 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[-1].number);
}
#line 7296 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 718:
#line 3517 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodcount = (yyvsp[-1].number);
}
#line 7304 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 719:
#line 3522 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodtime = (yyvsp[-1].number);
}
#line 7312 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 737:
#line 3546 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
#line 7320 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 738:
#line 3551 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay = (yyvsp[-1].number);
}
#line 7328 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3556 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay_channel = (yyvsp[-1].number);
}
#line 7336 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3561 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_user = (yyvsp[-1].number);
}
#line 7344 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3566 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_bans = (yyvsp[-1].number);
}
#line 7352 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3571 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_user_count = (yyvsp[-1].number);
}
#line 7360 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3576 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_server_count = (yyvsp[-1].number);
}
#line 7368 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3581 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
#line 7376 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3586 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
#line 7384 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3591 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
#line 7392 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3596 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodtime = (yyvsp[-1].number);
}
#line 7400 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3601 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
#line 7408 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3606 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.invite_throttle = (yyvsp[-1].number);
}
#line 7416 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3626 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
#line 7425 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3632 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.disable_remote_commands = yylval.number;
}
#line 7434 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3638 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
#line 7443 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3644 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_services = yylval.number;
}
#line 7452 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3650 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    ConfigServerHide.hidden_name = xstrdup(yylval.string);
  }
}
#line 7464 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3659 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (((yyvsp[-1].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[-1].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[-1].number);
  }
}
#line 7481 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3673 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hidden = yylval.number;
}
#line 7490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3679 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
#line 7499 "conf_parser.c" /* yacc.c:1646  */
    break;


#line 7503 "conf_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
